FILE	*APSFile;
FILE	*ORGFile;

int ReadStdHeader()
{
	unsigned char PatchType=1;
	unsigned char EncodingMethod=0;
//	char Magic[]="APS10";
	char aMagic[5];
	char Description[50+1];

	fread(aMagic,1,5,APSFile);
	fread(&PatchType,sizeof(PatchType),1,APSFile);
	fread(&EncodingMethod,sizeof(EncodingMethod),1,APSFile);
	fread (Description,1,50,APSFile);
	Description[50]=0;


	printf("Version: %s\n",aMagic);
//	if(strncmp(aMagic,Magic,5)!=0)
//	{
//		printf ("Not a Valid Patch File\n");
//		fclose (ORGFile);
//		fclose (APSFile);
//		return(-1);
//	}

	printf("Type: %s\n",(PatchType==1)?"Nintendo64":"Unknown");
//	if(PatchType!=1) // N64 Patch
//	{
//		printf ("Unable to Process Patch File\n");
//		fclose (ORGFile);
//		fclose (APSFile);
//		return(-1);
//	}

	printf("Encoding: %s\n",(EncodingMethod==0)?"Simple":"Unknown/New");
	if (EncodingMethod != 0) // Simple Encoding
//	{
//		printf ("Unknown or New Encoding Method\n");
//		fclose (ORGFile);
//		fclose (APSFile);
		return(-1);
//	}

	printf ("Description: %s\n\n",Description);
	fflush (stdout);
return(0);
}

int ReadN64Header (void)
{
	unsigned long MagicTest;
	unsigned char Buffer[8];
	unsigned char APSBuffer[8];
	int c;
	unsigned char CartID[2],Temp;
	unsigned char Teritory,APSTeritory;
    unsigned char APSFormat;

	fseek (ORGFile,0,SEEK_SET);
	fread (&MagicTest,sizeof (MagicTest),1,ORGFile);
	fread (Buffer,1,1,APSFile);
    APSFormat=Buffer[0];

	if (((MagicTest == 0x12408037) && (Buffer[0]==1)) || ((MagicTest != 0x12408037 && (Buffer[0]==0))))// 0 for Doctor Format, 1 for Everything Else
	{
//		printf ("Image is in the wrong format\n");
		fclose (ORGFile);
		fclose (APSFile);
		return(-1);
	}

	fseek (ORGFile,60, SEEK_SET); // Cart ID
	fread (CartID,1,2,ORGFile);
	fread (Buffer,1,2,APSFile);
	if (MagicTest == 0x12408037) // Doc
	{
		Temp=CartID[0];
		CartID[0]=CartID[1];
		CartID[1]=Temp;
	}
	if ((Buffer[0] != CartID[0]) || (Buffer[1] != CartID[1]))
	{
//		printf ("Not the Same Image\n");
		fclose (ORGFile);
		fclose (APSFile);
		return(-1);
	}

	if (MagicTest == 0x12408037)
		fseek (ORGFile,63,SEEK_SET); // Teritory
	else
		fseek (ORGFile,62,SEEK_SET);

	fread (&Teritory,sizeof (Teritory),1,ORGFile);
	fread (&APSTeritory,sizeof (APSTeritory),1,APSFile);
	if (Teritory != APSTeritory)
	{
//		printf ("Wrong Country\n");
//		if (!Force)
		{
			fclose (ORGFile);
			fclose (APSFile);
			return(-1);
		}
	}

	fseek (ORGFile,0x10, SEEK_SET); // CRC Header Position
	fread (Buffer,1,8,ORGFile);
	fread (APSBuffer,1,8,APSFile);

	if (MagicTest == 0x12408037) // Doc
    {
        Temp=Buffer[0];
        Buffer[0]=Buffer[1];
        Buffer[1]=Temp;
        Temp=Buffer[2];
        Buffer[2]=Buffer[3];
        Buffer[3]=Temp;
        Temp=Buffer[4];
        Buffer[4]=Buffer[5];
        Buffer[5]=Temp;
        Temp=Buffer[6];
        Buffer[6]=Buffer[7];
        Buffer[7]=Temp;
    }

	if ((APSBuffer[0] != Buffer[0]) || (APSBuffer[1] != Buffer[1]) ||
        (APSBuffer[2] != Buffer[2]) || (APSBuffer[3] != Buffer[3]) ||
     	(APSBuffer[4] != Buffer[4]) || (APSBuffer[5] != Buffer[5]) ||
	    (APSBuffer[6] != Buffer[6]) || (APSBuffer[7] != Buffer[7]))
	{
//		{ printf ("Incorrect Image\n"); fflush (stdout); }
//		if (!Force)
		{
			fclose (ORGFile);
			fclose (APSFile);
			return(-1);
		}
	}

	fseek (ORGFile,0,SEEK_SET);

	c=fgetc(APSFile);
	c=fgetc(APSFile);
	c=fgetc(APSFile);
	c=fgetc(APSFile);
	c=fgetc(APSFile);
return(0);
}


int
ReadSizeHeader (char *File1)
{
	long OrigSize;
	long APSOrigSize;
	unsigned char t;
	long i;

	fseek (ORGFile,0,SEEK_END);

	OrigSize = ftell (ORGFile);
//	OrigSize = fsize(fname);

	fread (&APSOrigSize,sizeof (APSOrigSize),1,APSFile);

	if (OrigSize != APSOrigSize) // Do File Resize
	{
		if (APSOrigSize < OrigSize)
		{
			int x;
			fclose (ORGFile);
			x = open (File1, O_WRONLY);
			if (ftruncate (x, APSOrigSize) != 0)
			{
//				printf ("Trunacte Failed\n");
			}
			close (x);
			ORGFile = fopen (File1,"rb+");
		}
		else
		{
			t = 0;
			for (i=0;i<(APSOrigSize-OrigSize);i++) fputc (t,ORGFile);
		}
	}

	fseek (ORGFile,0,SEEK_SET);
return(0);
}


int
ReadPatch ()
{
				unsigned char data;
				unsigned char len;
				int i;
	int APSReadLen;
	int Finished=0;
	unsigned char Buffer[256];
	long Offset;
	unsigned char Size;

	while (!Finished)
	{
		APSReadLen = fread (&Offset,sizeof (Offset),1,APSFile);
		if (APSReadLen == 0)
		{
			Finished=1;
		}
		else
		{
			fread (&Size,sizeof (Size),1,APSFile);
			if (Size != 0)
			{
				fread (Buffer,1,Size,APSFile);
				if ((fseek (ORGFile,Offset,SEEK_SET)) != 0)
				{
//					printf ("Seek Failed\n");
					fflush (stdout);
					return(-1);
				}
				fwrite (Buffer,1,Size,ORGFile);
			}
			else
			{

				fread (&data,sizeof(data),1,APSFile);
				fread (&len,sizeof(data),1,APSFile);

				if ((fseek (ORGFile,Offset,SEEK_SET)) != 0)
				{
//					printf ("Seek Failed\n");
					fflush (stdout);
					return(-1);
				}

				for (i=0;i<len;i++) fputc (data,ORGFile);
			}
		}
	}
return(0);
}

int
aps (char *name, char *option2)
{
	if(ReadStdHeader()==-1)return(-1);

	if(ReadN64Header()==-1)return(-1);

	if(ReadSizeHeader(name)==-1)return(-1);

	if(ReadPatch()==-1)return(-1);

	fclose (ORGFile);
	fclose (APSFile);

return(0);
}


















FILE	*APSFile;
FILE	*ORGFile;
FILE	*NEWFile;
int		ChangeFound;

//	printf ("N64CAPS <options> <Original File> <Modified File> <Output APS File>\n");

void
WriteStdHeader (char *Desc)
{
	char Description[50];
#define TYPE_N64 1
unsigned char PatchType=TYPE_N64;
#define ENCODINGMETHOD 0 // Very Simplistic Method
unsigned char EncodingMethod=ENCODINGMETHOD;

	fwrite ("APS10",1,5,APSFile);
	fwrite (&PatchType,sizeof (PatchType),1,APSFile);
	fwrite (&EncodingMethod,sizeof (EncodingMethod),1,APSFile);

	memset (Description,' ',50);
	strcpy (Description,Desc);
	Description[strlen(Desc)]=' ';

	fwrite (Description,1,50,APSFile);

}

void
WriteN64Header ()
{
	unsigned long MagicTest;
	unsigned char Buffer[8];
	unsigned char Teritory;
	unsigned char CartID[2],Temp;

	fread (&MagicTest,sizeof (MagicTest),1,ORGFile);

	if (MagicTest == 0x12408037) // 0 for Doctor Format, 1 for Everything Else
		fputc (0,APSFile);
	else
		fputc (1,APSFile);


	fseek  (ORGFile,60,SEEK_SET);
	fread  (CartID,1,2,ORGFile);
	if (MagicTest == 0x12408037) // Doc
	{
		Temp=CartID[0];
		CartID[0]=CartID[1];
		CartID[1]=Temp;
	}
	fwrite (CartID,1,2,APSFile);

	if (MagicTest == 0x12408037) // Doc
		fseek (ORGFile,63,SEEK_SET);
	else
		fseek (ORGFile,62,SEEK_SET);
	fread  (&Teritory,sizeof (Teritory),1,ORGFile);
	fwrite (&Teritory,sizeof (Teritory),1,APSFile);

	fseek (ORGFile,0x10, SEEK_SET); // CRC Header Position
	fread (Buffer,1,8,ORGFile);

	if (MagicTest == 0x12408037) // Doc
        {
                Temp=Buffer[0];
                Buffer[0]=Buffer[1];
                Buffer[1]=Temp;
                Temp=Buffer[2];
                Buffer[2]=Buffer[3];
                Buffer[3]=Temp;
                Temp=Buffer[4];
                Buffer[4]=Buffer[5];
                Buffer[5]=Temp;
                Temp=Buffer[6];
                Buffer[6]=Buffer[7];
                Buffer[7]=Temp;
        }

	fwrite (Buffer,1,8,APSFile);

	fseek (ORGFile,0,SEEK_SET);

	fputc (0,APSFile); // PAD
	fputc (0,APSFile); // PAD
	fputc (0,APSFile); // PAD
	fputc (0,APSFile); // PAD
	fputc (0,APSFile); // PAD
}


void
WriteSizeHeader ()
{
	long NEWSize,ORGSize;

	fseek (NEWFile,0,SEEK_END);
	fseek (ORGFile,0,SEEK_END);

	NEWSize = ftell (NEWFile);
	ORGSize = ftell (ORGFile);

	fwrite (&NEWSize,sizeof (NEWSize),1,APSFile);

	if (ORGSize != NEWSize) ChangeFound=1;

	fseek (NEWFile,0,SEEK_SET);
	fseek (ORGFile,0,SEEK_SET);
}


void
WritePatch ()
{
	long ORGReadLen;
	long NEWReadLen;
	int Finished=0;
	unsigned char ORGBuffer[255];
	unsigned char NEWBuffer[255];
	long FilePos;
	int i;
	long ChangedStart=0;
	long ChangedOffset=0;
	int ChangedLen=0;
	int State;

	fseek (ORGFile,0,SEEK_SET);
	fseek (NEWFile,0,SEEK_SET);

	FilePos = 0;

	while (!Finished)
	{
		ORGReadLen = fread (ORGBuffer,1,255,ORGFile);
		NEWReadLen = fread (NEWBuffer,1,255,NEWFile);

		if (ORGReadLen != NEWReadLen)
		{
			int a;

			for (a=ORGReadLen;a<NEWReadLen;a++) ORGBuffer[a]=0;
		}

		i=0;
		State=0;

		if (NEWReadLen != 0)
		{
		while (i<NEWReadLen)
		{
			switch (State)
			{
			case 0:
				if (NEWBuffer[i] != ORGBuffer[i])
				{
					State=1;
					ChangedStart=FilePos+i;
					ChangedOffset=i;
					ChangedLen=1;
					ChangeFound=1;
				}
				i++;
				break;
			case 1:
				if (NEWBuffer[i] != ORGBuffer[i])
				{
					ChangedLen++;
					i++;
				}
				else
					State=2;
				break;
			case 2:
				fwrite (&ChangedStart,sizeof (ChangedStart),1,APSFile);
				fputc  ((ChangedLen&0xff),APSFile);
				fwrite (NEWBuffer+(ChangedOffset),1,ChangedLen,APSFile);
				State=0;
				break;
			}
		}
		}

		if (State!=0)
		{
			if (ChangedLen==0) ChangedLen=255;
			fwrite (&ChangedStart,sizeof (ChangedStart),1,APSFile);
			fputc ((ChangedLen&0xff),APSFile);
			fwrite (NEWBuffer+(ChangedOffset),1,ChangedLen,APSFile);
		}

		if (NEWReadLen==0) Finished=1;
		FilePos+=NEWReadLen;
	}
}


int caps(char *name, char *option2)
{
	char	OutFile[256];
	char	Description[81];
char buf[4096];
	
	ChangeFound = 0;

	Description[0]=0;

	if(!(ORGFile=fopen(name,"r+b")))
	{
		return(-1);
	}

	if(!(NEWFile=fopen(option2,"rb")))
	{
		fclose(ORGFile);
		return(-1); 
	}

	strcpy(buf,name);
	buf[strcspn(buf,".")+1]=0;
	strcat(buf,isstrlwr(buf)?"aps":"APS");
	
	if(!(APSFile = fopen (buf,"wb")))
	{
		fclose(ORGFile);
		fclose(NEWFile);
		return(-1);
	}

//		printf ("Writing Headers...");
//		fflush (stdout);

	WriteStdHeader (Description);

	WriteN64Header ();

	WriteSizeHeader ();

//	printf ("Done\nFinding Changes..."); fflush (stdout);

	WritePatch ();

//	printf ("Done\n"); fflush (stdout);

	fclose (NEWFile);
	fclose (ORGFile);
	fclose (APSFile);

	if (!ChangeFound)
	{
//		printf ("No Changes Found\n");
		fflush (stdout);
		unlink (OutFile);
	}

	return (0);
}
