#define GBSTART 0x100
#define GBHEADER0 512
#define MBIT 131072

int gbchksum(char *name,long hsize)
{
FILE *fh;
long i;
long calcromsize = 0;
unsigned short cartchecksum = 0, calcchecksum = 0;
unsigned char cartcompchecksum = 0, calccompchecksum = 0;
int ch;
                                                
fhexdump(name,GBSTART+hsize+0x4d,3);
if(!(fh=fopen(name,"r+b")))return(-1);

while (fsize(name,hsize) > (0x8000L << calcromsize))calcromsize += 1;
 fseek(fh, 0+hsize, SEEK_SET);
                        
for (i = 0; i < (0x8000L << calcromsize); i += 1) 
{
	ch = fgetc(fh);
	if (ch == EOF)ch = 0;

	if (i < 0x0134L)calcchecksum += ch;
	else if (i < 0x014DL) 
	{
		calccompchecksum += ch;
		calcchecksum += ch;
	} 
	else if (i == 0x014DL)cartcompchecksum = ch;
	else if (i == 0x014EL)cartchecksum = ch << 8;
	else if (i == 0x014FL)cartchecksum |= ch;
	else calcchecksum += ch;
}

calccompchecksum = 0xE7 - calccompchecksum;
calcchecksum += calccompchecksum;

if (cartchecksum != calcchecksum) 
{
	fflush(fh);
	fseek(fh, 0x014EL+hsize, SEEK_SET);
		fputc(calcchecksum >> 8, fh);
		fputc(calcchecksum & 0xFF, fh);
	fflush(fh);
} 
//else printf("\tChecksum is OK\n");


if (cartcompchecksum != calccompchecksum) 
{
	fflush(fh);
	fseek(fh, 0x014DL+hsize, SEEK_SET);
	fputc(calccompchecksum, fh);
	fflush(fh);
}
//else printf("\tCompChecksum is OK\n");

fclose(fh);

fhexdump(name,GBSTART+hsize+0x4d,3);
printf("\n");
	return(0);
}

//options

#define NFO	11//show rom info
#define NAME 55//change name
#define CHK     5//fix checksum
#define MGD	7
#define SSC	8

//this single routine does all the gameboy stuff

int gameboy(char *name,int option,char *option2)
{
//option2[0] = header: '1'=yes, ' '=no, '?'=unknown

	char *romtype[] =
	{
		"ROM only",\
		"ROM+MBC1",\
		"ROM+MBC1+RAM",\
		"ROM+MBC1+RAM+BATTERY",\
		"4",\
		"ROM+MBC2",\
		"ROM+MBC2+BATTERY",\
		"7",\
		"ROM+RAM",\
		"ROM+RAM+BATTERY",\
		"10",\
		"ROM+MMM01",\
		"ROM+MMM01+RAM",\
  		"ROM+MMM01+RAM+BATTERY",\
		"14",\
		"ROM+MBC3+BATTERY+TIMER",\
 		"ROM+MBC3+RAM+BATTERY+TIMER",\
		"ROM+MBC3",\
		"ROM+MBC3+RAM",\
		"ROM+MBC3+RAM+BATTERY",\
		"20",\
		"ROM+MBC4",\
		"ROM+MBC4+RAM",\
		"ROM+MBC4+RAM+BATTERY",\
		"24",\
		"ROM+MBC5",\
  		"ROM+MBC5+RAM",\
		"ROM+MBC5+RAM+BATTERY",\
		"ROM+MBC5+RUMBLE",\
		"ROM+MBC5+RAM+RUMBLE",\
 		"ROM+MBC5+RAM+BATTERY+RUMBLE",\
		"31",\
"32",\
"33",\
"34",\
"35",\
"36",\
"37",\
"38",\
"39",\
"40",\
"41",\
"42",\
"43",\
"44",\
"45",\
"46",\
"47",\
"48",\
"49",\
"50",\
"51",\
"52",\
"53",\
"54",\
"55",\
"56",\
"57",\
"58",\
"59",\
"60",\
"61",\
"62",\
"63",\
"64",\
"65",\
"66",\
"67",\
"68",\
"69",\
"70",\
"71",\
"72",\
"73",\
"74",\
"75",\
"76",\
"77",\
"78",\
"79",\
"80",\
"81",\
"82",\
"83",\
"84",\
"85",\
"86",\
"87",\
"88",\
"89",\
"90",\
"91",\
"92",\
"93",\
"94",\
"95",\
"96",\
"97",\
"98",\
"99",\
"100",\
"101",\
"102",\
"103",\
"104",\
"105",\
"106",\
"107",\
"108",\
"109",\
"110",\
"111",\
"112",\
"113",\
"114",\
"115",\
"116",\
"117",\
"118",\
"119",\
"120",\
"121",\
"122",\
"123",\
"124",\
"125",\
"126",\
"127",\
"128",\
"129",\
"130",\
"131",\
"132",\
"133",\
"134",\
"135",\
"136",\
"137",\
"138",\
"139",\
"140",\
"141",\
"142",\
"143",\
"144",\
"145",\
"146",\
"147",\
"148",\
"149",\
"150",\
"151",\
"152",\
"153",\
"154",\
"155",\
"156",\
"157",\
"158",\
"159",\
"160",\
"161",\
"162",\
"163",\
"164",\
"165",\
"166",\
"167",\
"168",\
"169",\
"170",\
"171",\
"172",\
"173",\
"174",\
"175",\
"176",\
"177",\
"178",\
"179",\
"180",\
"181",\
"182",\
"183",\
"184",\
"185",\
"186",\
"187",\
"188",\
"189",\
"190",\
"191",\
"192",\
"193",\
"194",\
"195",\
"196",\
"197",\
"198",\
"199",\
"200",\
"201",\
"202",\
"203",\
"204",\
"205",\
"206",\
"207",\
"208",\
"209",\
"210",\
"211",\
"212",\
"213",\
"214",\
"215",\
"216",\
"217",\
"218",\
"219",\
"220",\
"221",\
"222",\
"223",\
"224",\
"225",\
"226",\
"227",\
"228",\
"229",\
"230",\
"231",\
"232",\
"233",\
"234",\
"235",\
"236",\
"237",\
"238",\
"239",\
"240",\
"241",\
"242",\
"243",\
"244",\
"245",\
"246",\
"247",\
"248",\
"249",\
"250",\
		"251",\
		"Nintendo Pocket Camera",\
		"Bandai TAMA5",\
		"Hudson HuC-3",\
		"Hudson HuC-1"
	};

char *maker[]={\
"0",\
"Nintendo",\
"2",\
"3",\
"4",\
"5",\
"6",\
"7",\
"Capcom",\
"9",\
"Jaleco",\
"Coconuts",\
"12",\
"13",\
"14",\
"15",\
"16 10",\
"17 11",\
"18 12",\
"19 13",\
"20 14",\
"21 15",\
"22 16",\
"23 17",\
"Hudson Soft",\
"25 19",\
"26 1a",\
"27 1b",\
"28 1c",\
"29 1d",\
"30 1e",\
"31 1f",\
"32 20",\
"33 21",\
"34 22",\
"35 23",\
"36 24",\
"37 25",\
"38 26",\
"39 27",\
"40 28",\
"41 29",\
"42 2a",\
"43 2b",\
"44 2c",\
"45 2d",\
"46 2e",\
"47 2f",\
"48 30",\
"49 31",\
"50 32",\
"Nintendo",\
"52 34",\
"53 35",\
"54 36",\
"55 37",\
"56 38",\
"57 39",\
"58 3a",\
"59 3b",\
"60 3c",\
"61 3d",\
"62 3e",\
"63 3f",\
"64 40",\
"65 41",\
"66 42",\
"67 43",\
"68 44",\
"69 45",\
"70 46",\
"Spectrum Holobyte",\
"72 48",\
"Irem",\
"74 4a",\
"75 4b",\
"76 4c",\
"77 4d",\
"78 4e",\
"79 4f",\
"Absolute Entertainment",\
"Acclaim",\
"Activision",\
"American Sammy",\
"Gametek",\
"Park Place",\
"LJN",\
"87 57",\
"88 58",\
"89 59",\
"Bitmap Brothers/Mindscape",\
"91 5b",\
"92 5c",\
"Tradewest",\
"94 5e",\
"95 5f",\
"Titus",\
"Virgin",\
"98 62",\
"99 63",\
"100 64",\
"101 65",\
"102 66",\
"Ocean",\
"104 68",\
"105 69",\
"106 6a",\
"107 6b",\
"108 6c",\
"109 6d",\
"110 6e",\
"ElectroBrain",\
"Infogrames",\
"113 71",\
"Broderbund",\
"115 73",\
"116 74",\
"117 75",\
"118 76",\
"119 77",\
"120 78",\
"Accolade",\
"Triffix Entertainment",\
"123 7b",\
"124 7c",\
"125 7d",\
"126 7e",\
"Kemco",\
"128 80",\
"129 81",\
"130 82",\
"Lozc",\
"132 84",\
"133 85",\
"134 86",\
"135 87",\
"136 88",\
"137 89",\
"138 8a",\
"Bullet-Proof Software",\
"Vic Tokai",\
"141 8d",\
"142 8e",\
"143 8f",\
"144 90",\
"145 91",\
"146 92",\
"Tsuburava",\
"148 94",\
"149 95",\
"150 96",\
"151 97",\
"152 98",\
"ARC",\
"154 9a",\
"155 9b",\
"Imagineer",\
"157 9d",\
"158 9e",\
"159 9f",\
"160 a0",\
"161 a1",\
"162 a2",\
"163 a3",\
"Konami",\
"165 a5",\
"Kawada",\
"Takara",\
"168 a8",\
"Technos Japan",\
"Broderbund",\
"Namcot",\
"172 ac",\
"173 ad",\
"174 ae",\
"175 af",\
"176 b0",\
"ASCII/Nexoft",\
"178 b2",\
"179 b3",\
"Enix",\
"181 b5",\
"HAL",\
"183 b7",\
"184 b8",\
"185 b9",\
"186 ba",\
"SunSoft",\
"188 bc",\
"Imagesoft",\
"190 be",\
"Sammy",\
"Taito",\
"193 c1",\
"Kemco",\
"SquareSoft",\
"196 c4",\
"Data East",\
"Tonkin House",\
"199 c7",\
"200 c8",\
"201 c9",\
"Palcom/Ultra",\
"VAP",\
"204 cc",\
"205 cd",\
"FCI/Pony Canyon",\
"207 cf",\
"208 d0",\
"Sofel",\
"Quest",\
"211 d3",\
"212 d4",\
"213 d5",\
"214 d6",\
"215 d7",\
"216 d8",\
"Banpresto",\
"Tomy",\
"219 db",\
"220 dc",\
"NCS",\
"222 de",\
"Altron",\
"224 e0",\
"Towachiki",\
"226 e2",\
"227 e3",\
"228 e4",\
"Epoch",\
"230 e6",\
"231 e7",\
"Asmik",\
"233 e9",\
"King Records",\
"Atlus",\
"236 ec",\
"237 ed",\
"IGS",\
"239 ef",\
"240 f0",\
"241 f1",\
"242 f2",\
"243 f3",\
"244 f4",\
"245 f5",\
"246 f6",\
"247 f7",\
"248 f8",\
"249 f9",\
"250 fa",\
"251 fb",\
"252 fc",\
"253 fd",\
"254 fe",\
"255 ff"
};

/*char *country[]={\
"0",\
"1",\
"2",\
"3",\
"4",\
"5",\
"6",\
"7",\
"8",\
"9",\
"10",\
"11",\
"12",\
"13",\
"14",\
"15",\
"16",\
"17",\
"18",\
"19",\
"20",\
"21",\
"22",\
"23",\
"24",\
"25",\
"26",\
"27",\
"28",\
"29",\
"30",\
"31",\
"32",\
"33",\
"34",\
"35",\
"36",\
"37",\
"38",\
"39",\
"40",\
"41",\
"42",\
"43",\
"44",\
"45",\
"46",\
"47",\
"48",\
"49",\
"50",\
"51",\
"52",\
"53",\
"54",\
"55",\
"56",\
"57",\
"58",\
"59",\
"60",\
"61",\
"62",\
"63",\
"64",\
"65",\
"66",\
"67",\
"Germany",\
"USA",\
"70",\
"71",\
"72",\
"73",\
"Japan",\
"75",\
"76",\
"77",\
"78",\
"79",\
"Europe",\
"81",\
"82",\
"83",\
"84",\
"Australia",\
"86",\
"87",\
"88",\
"89",\
"90",\
"91",\
"92",\
"93",\
"94",\
"95",\
"96",\
"97",\
"98",\
"99",\
"100",\
"101",\
"102",\
"103",\
"104",\
"105",\
"106",\
"107",\
"108",\
"109",\
"110",\
"111",\
"112",\
"113",\
"114",\
"115",\
"116",\
"117",\
"118",\
"119",\
"120",\
"121",\
"122",\
"123",\
"124",\
"125",\
"126",\
"127",\
"128",\
"129",\
"130",\
"131",\
"132",\
"133",\
"134",\
"135",\
"136",\
"137",\
"138",\
"139",\
"140",\
"141",\
"142",\
"143",\
"144",\
"145",\
"146",\
"147",\
"148",\
"149",\
"150",\
"151",\
"152",\
"153",\
"154",\
"155",\
"156",\
"157",\
"158",\
"159",\
"160",\
"161",\
"162",\
"163",\
"164",\
"165",\
"166",\
"167",\
"168",\
"169",\
"170",\
"171",\
"172",\
"173",\
"174",\
"175",\
"176",\
"177",\
"178",\
"179",\
"180",\
"181",\
"182",\
"183",\
"184",\
"185",\
"186",\
"187",\
"188",\
"189",\
"190",\
"191",\
"192",\
"193",\
"194",\
"195",\
"196",\
"197",\
"198",\
"199",\
"200",\
"201",\
"202",\
"203",\
"204",\
"205",\
"206",\
"207",\
"208",\
"209",\
"210",\
"211",\
"212",\
"213",\
"214",\
"215",\
"216",\
"217",\
"218",\
"219",\
"220",\
"221",\
"222",\
"223",\
"224",\
"225",\
"226",\
"227",\
"228",\
"229",\
"230",\
"231",\
"232",\
"233",\
"234",\
"235",\
"236",\
"237",\
"238",\
"239",\
"240",\
"241",\
"242",\
"243",\
"244",\
"245",\
"246",\
"247",\
"248",\
"249",\
"250",\
"251",\
"252",\
"253",\
"254",\
"255",\
};*/
char *copier[]={"Multi Game*/MGD2/RAW","Super Smart Card/SSC"};
register long x,y;
char romname[4096];
char romheader[80];
char buf[32768];
char buf2[4096];
unsigned long hsize=0;
char header[512];
int z=0;
FILE *fh;
    
strcpy(romname,name);


//first indentify the rom as a gameboy rom and test for header

x=fgetc2(romname,GBSTART+hsize+0x047);
if(x<252&&x>30)
{
	hsize=GBHEADER0;
	x=fgetc2(romname,GBSTART+hsize+0x047);
	if(x<252&&x>30){if(!option)return(-1);}
}

hsize=0;
if(fgetc2(romname,GBSTART+hsize+0x0)!=0x0||fgetc2(romname,GBSTART+hsize+0x01)!=0x0c3)hsize=GBHEADER0;
if(fgetc2(romname,GBSTART+hsize+0x0)!=0x0||fgetc2(romname,GBSTART+hsize+0x01)!=0x0c3)
{if(!option)return(-1);}

if(option2[0]!='?')hsize=((option2[0]=='0')?0:GBHEADER0);

switch(option)
{
//case PAD:
//	strcpy(romname,fmkrom(romname,hsize));
//	strcpy(buf,romname);
//	fpad(buf,hsize);
//break;

case NAME:
	strcat(option2,"\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0");
	fstrncpy(romname,&option2[16],GBSTART+hsize+0x034,16);
	gameboy(name,NFO,option2);
break;

case SSC:
	if(hsize!=0)return(-1);
	memset(header,0,sizeof(header));

	header[1]=((fsize(romname,hsize)/8192)/256);
	header[0]=((fsize(romname,hsize)/8192)-(header[1]*256));
	header[8]=0xaa;
	header[9]=0xbb;
	header[10]=0x02;

	strcpy(buf,romname);
	buf[strcspn(buf,".")+1]=0;
	strcat(buf,isstrlwr(buf)?"tmp":"TMP");
	rename(romname,buf);

	if((fh=fopen(romname,"wb"))!=0)
	{
		fwrite(header,sizeof(header),1,fh);
		fclose(fh);
	}

	fcopy(buf,0,romname,"ab");
	remove(buf);
break;

case MGD:
	strcpy(buf,isstrlwr(romname)?"gb":"GB");
	strcpy(buf2,romname);
	buf2[strcspn(buf2,".")]=0;
	strcat(buf2,"________");
	strcat(buf,buf2);
	buf[7]='_';
	buf[8]=0;
	sprintf(buf2,"%s.%03lu",buf,(unsigned long)fsize(romname,hsize)/MBIT);
	strcpy(buf,romname);
	fcopy(buf,hsize,buf2,"wb");
	remove(buf);

//automatically create MGH name file

//	memset(mgh,0,sizeof(mgh));
//	mgh[0]='M';
//	mgh[1]='G';
//	mgh[2]='H';
//	mgh[3]=0x1a;
//	mgh[31]=0xff;
//
//	for(x=16;x<31;x++)mgh[x]=fgetc2(romname,SNESSTART+hirom+hsize+16+x);
//
//	strcpy(buf,romname);
//	buf[strcspn(buf,".")+1]=0;
//	strcat(buf,isstrlwr(buf)?"mgh":"MGH");
//
//	if(!(fh=fopen(buf,"wb")))break;
//	fwrite(mgh,sizeof(mgh),1,fh);
//	fclose(fh);
break;


case CHK:
	gbchksum(romname,hsize);//rewrite/fix checksum
break;
        
case NFO:
	fhexdump(romname,GBSTART+hsize,sizeof(romheader));
	printf("\n");

	if(fgetc2(romname,GBSTART+hsize+0x043)==0x080)printf("Color GameBoy\n");
	else if(fgetc2(romname,GBSTART+hsize+0x046)==0x03)printf("(Super GameBoy)\n");
	else printf("GameBoy/(Super GameBoy)/GameBoy Pocket/Color GameBoy/GameBoy Advance\n");

	printf("%s\n",(!hsize)?copier[0]:copier[1]);
	for(x=0;x<20;x++)buf[x]=fgetc2(romname,GBSTART+hsize+x+0x034);
	buf[16]=0;
	printf(buf);
	printf("\n");

//	if(fgetc2(romname,GBSTART+hsize+0x04b)==0x33)
	printf("%s\n",maker[fgetc2(romname,GBSTART+hsize+0x04b)]);

	printf("%s\n",(fgetc2(romname,GBSTART+hsize+0x04a)==0x0)?"Japan":"U.S.A./Europe");
	printf("%ld bytes (%.4f MBit)\n",fsize(romname,hsize),(float)fsize(romname,hsize)/MBIT);


printf("\n");


	if((x=fpad(romname,hsize,"rb"))!=-1)
	{
		if(!x)printf("Padded: No\n");
		else printf("Padded: Maybe, %ld bytes (%.4f MBit)\n",x,(float)x/MBIT);
	}

	printf("Internal Size: %.4f MBit\n",(float)(2<<fgetc2(romname,GBSTART+hsize+0x048))*16384/MBIT);
	printf("RomType: %s\n",romtype[fgetc2(romname,GBSTART+hsize+0x047)]);

	x=(fsize(romname,hsize)-(fsize(romname,hsize)/(MBIT/4))*(MBIT/4));
	if(!x)printf("Intro/Trainer: No\n");
	else printf("Intro/Trainer: Yes, %ld bytes\n",x);


/*
0148       ROM size:
           0 - 256kBit =  32kB =  2 banks
           1 - 512kBit =  64kB =  4 banks
           2 -   1MBit = 128kB =  8 banks
           3 -   2MBit = 256kB = 16 banks
           4 -   4MBit = 512kB = 32 banks
0149       RAM size:
           0 - None 
           1 -  16kBit =  2kB = 1 bank
           2 -  64kBit =  8kB = 1 bank
           3 - 256kBit = 32kB = 4 banks
*/
	z=fgetc2(romname,GBSTART+hsize+0x049);
        if(!z)printf("Save RAM: No\n");
	else
	{
                z = (z & 0x03) * 2;
                                z =( z ? (1 << (z - 1)) : 0);

        printf("Save RAM: Yes, %d kbytes\n",z);
	}
	printf("Version: 1.%d\n",fgetc2(romname,GBSTART+hsize+0x04c));
	printf("Start Address: %02x%02x\n",fgetc2(romname,GBSTART+hsize+0x03),fgetc2(romname,GBSTART+hsize+0x02));


	x=25;    
      for(y=0x034;y<0x04D;y++) x+=fgetc2(name,GBSTART+hsize+y);
	x=(0x100-(x&0x0ff))&0x0ff;
	printf("CheckSum: %02x%02x, %s %02x\n",fgetc2(romname,GBSTART+hsize+0x4e),fgetc2(romname,GBSTART+hsize+0x4f),(x==fgetc2(romname,GBSTART+hsize+0x04d))?"ok":"bad",(int)x);

	printf("Complement Check: %02x\n",fgetc2(romname,GBSTART+hsize+0x04d));




	printf("\n");
break;

default:
break;
}
return(0);
}
