char *mkines(char *name)
{
char *buf3;
char buf[4096],buf2[4096];
char nesname[4096];
char romheader[16];
FILE *fh;

//detect multifile pasofami format and join them into one single .NES file

if(!(buf3=strrchr(name,'/')))buf3=name;
else buf3++;
strcpy(buf,buf3);
strupr(buf);

if(!strdcmp(buf,".HDR")||\
!strdcmp(buf,".PRM")||\
!strdcmp(buf,".700")||\
!strdcmp(buf,".CHR")||\
!strdcmp(buf,".PRG"))
{
	strcpy(nesname,name);
	nesname[strcspn(nesname,".")+1]=0;
	strcat(nesname,isstrlwr(nesname)?"nes":"NES");

	strcpy(buf,name);
	buf[strcspn(buf,".")+1]=0;
	strcat(buf,isstrlwr(buf)?"prm":"PRM");
	fstrncpy(buf2,buf,0,fsize(buf,0));

	if(!(fh=fopen(nesname,"wb")))return(name);
	sprintf(romheader,"NES%c%c%c%c%c%c%c%c%c%c%c%c%c",0,0,0,0,0,0,0,0,0,0,0,0,0);
	fwrite(romheader,sizeof(romheader),1,fh);
	fclose(fh);

	strcpy(buf,name);

	buf[strcspn(buf,".")+1]=0;
	strcat(buf,isstrlwr(buf)?"prg":"PRG");
	fcopy3(buf,0,fsize(buf,0),nesname,"ab");

	buf[strcspn(buf,".")+1]=0;
	strcat(buf,isstrlwr(buf)?"chr":"CHR");
	fcopy3(buf,0,fsize(buf,0),nesname,"ab");

	strcpy(name,nesname);
}
if(!strdcmp(buf,".FDS"))
{
//fds >> nes
}
return(name);
}

unsigned long neschksum(char *name,long hsize)
{
//what's the real pseudo chksum routine?
	return(fchksum(name,hsize,4));
}
#define MBIT 131072

//options

#define NFO	11//show rom info
#define FDS 64
#define FFE 65
#define PASO 66
#define INES 67
#define INESHD 68 //extract or add inesheader

//this single routine does all the nes stuff

int nes(char *name,int option,char *option2)
{
#define NESSTART 0
#define NESHEADER0 512

typedef struct 
{
	unsigned long chksum;
	char *name;
	int country;
	int maker;
	char *date;
} ROM_TYPE;

ROM_TYPE ROM_LIST[] = {
#include "nes_db.h"
};

char *maker[]={"?",\
"A-Wave",\
"ASCII",\
"Absolute Entertainment",\
"Acclaim",\
"Active Enterprises",\
"Activision",\
"Activision/Bullet Proof",\
"Akujin",\
"Altron",\
"American Game Carts",\
"American Sammy Corp.",\
"American Sammy",\
"American Softworks",\
"American Technos",\
"American Video",\
"Angel",\
"Arcadia Systems",\
"Asder",\
"Ask Koudansha",\
"Asmik",\
"Athena",\
"Atlus",\
"BPS",\
"Bandai",\
"Banpresto",\
"Beam Software",\
"Beam Software/Mattel",\
"Bothtec",\
"Broderbund",\
"Bullet-Proof",\
"Bunch Games",\
"CBS Sony Group",\
"Camerica",\
"Capcom",\
"Cart-Saint",\
"Casady",\
"Character Soft",\
"Chris Covell",\
"Coconuts Japan",\
"Color Dreams",\
"Cony",\
"Crush Productions",\
"Culture Brain",\
"DB Soft",\
"Darknight13",\
"Data East",\
"Disconnected Translations",\
"Dragoon-X",\
"EAV",\
"Electro Brain",\
"Electronic Arts",\
"Elite",\
"Enix",\
"Epic-Sony Records",\
"Epoch Yashiro",\
"Eurocom",\
"FCI",\
"FCI/Pony Canyon",\
"Face",\
"Fuji Television",\
"G.O 1",\
"Gaijin Productions",\
"Gakushuu Kenkyuusha",\
"Galoob",\
"GameTek",\
"Grimlick",\
"Hal America Inc.",\
"Hal America",\
"Hal Kenkyuujo",\
"Hal",\
"Halken",\
"Hector",\
"Hero",\
"Hi Tech Expressions",\
"High Score Media Work",\
"Hot B",\
"Hudson Soft",\
"Human",\
"HummingBird Soft",\
"I'Max",\
"IGS",\
"INTV",\
"Ian Bell",\
"Imagineer",\
"Induction Produce",\
"Infocom",\
"Infogrames",\
"Interplay",\
"Irem",\
"J2E Translations",\
"JVC",\
"Jaleco",\
"K Amusement Lease",\
"Kakenhi",\
"Kasady",\
"Kawada",\
"Kemco",\
"King Records",\
"Koei",\
"Konami",\
"Kotobuki System",\
"Kyuugo Boueki",\
"LHN",\
"LJN",\
"Lucasfilm Games",\
"M&M",\
"Manipulate",\
"Masiya",\
"Matchbox",\
"Mattel",\
"Meldac",\
"Memblers",\
"Microprose",\
"Milton Bradley",\
"Mindscape",\
"NTVIC",\
"Namco",\
"Namcot",\
"Nameo",\
"Natsume",\
"Naxat",\
"Neo Demiforce",\
"Nexoft",\
"Nihon Bussan",\
"Nihon Computer System",\
"Nintendo",\
"Ocean",\
"Pack-In Video",\
"Palcom",\
"Panesian",\
"Parker Brothers",\
"Pixel",\
"Pony Canyon",\
"Pope Hentai",\
"Proto",\
"Quest",\
"RCM Group",\
"RKH Translation",\
"RPGe",\
"Rage Games",\
"Rare Ltd.",\
"Romstar",\
"SNK",\
"Sammy",\
"Sanritsu Denki",\
"Seta USA",\
"Seta",\
"Sigma Shouji",\
"Sigma",\
"Sofel",\
"Soft Pro",\
"Software Toolworks",\
"Sony Imagesoft",\
"Square Soft",\
"Square",\
"Sunsoft",\
"SuperVision",\
"T*HQ",\
"TSS",\
"Taito",\
"Takara",\
"Takeru",\
"Taxan",\
"Technos Japan",\
"Tecmo",\
"Tengen",\
"Tengen/Mindscape",\
"Tennessee Carmel-Veilleux",\
"The Mad Hacker",\
"The Sales Curve",\
"The Spoony Bard",\
"Titus Software",\
"Toho",\
"Tokuma Shoten",\
"Tomy",\
"Tonkin House",\
"Tony Young",\
"Touei Douga",\
"Toukyou Shoseki",\
"Toushiba EMI",\
"Towa Chiki",\
"Tradewest",\
"TransBRC",\
"Triffix",\
"Tsang Hai",\
"UBI Soft",\
"UPL",\
"Ultra Games",\
"Ultra Games/Konami",\
"Use",\
"Vap",\
"Varie",\
"Vic Tokai",\
"Victor Musical Industries",\
"Victor Ongaku Sangyou",\
"Virgin Games",\
"Visco",\
"Wakd Hacks",\
"Will B.",\
"Wisdom Tree",\
"Yonezawa",\
"Yutaka",\
"203",\
"204",\
"205",\
"206",\
"207",\
"208",\
"209",\
"210",\
"211",\
"212",\
"213",\
"214",\
"215",\
"216",\
"217",\
"218",\
"219",\
"220",\
"221",\
"222",\
"223",\
"224",\
"225",\
"226",\
"227",\
"228",\
"229",\
"230",\
"231",\
"232",\
"233",\
"234",\
"235",\
"236",\
"237",\
"238",\
"239",\
"240",\
"241",\
"242",\
"243",\
"244",\
"245",\
"246",\
"247",\
"248",\
"249",\
"250",\
"251",\
"252",\
"253",\
"254",\
"Unknown Maker"\
};

char *country[]={\
"Japan",\
"U.S.A.",\
"Europe, Australia, Oceania and Asia",\
"Sweden",\
"Finland",\
"Denmark",\
"France",\
"Holland",\
"Spain",\
"Germany, Austria and Switzerland",\
"Italy",\
"Hong Kong and China",\
"Indonesia",\
"Korea",\
"14",\
"15",\
"16",\
"17",\
"18",\
"19",\
"20",\
"21",\
"22",\
"23",\
"24",\
"25",\
"26",\
"27",\
"28",\
"29",\
"30",\
"31",\
"32",\
"33",\
"34",\
"35",\
"36",\
"37",\
"38",\
"39",\
"40",\
"41",\
"42",\
"43",\
"44",\
"45",\
"46",\
"47",\
"48",\
"49",\
"50",\
"51",\
"52",\
"53",\
"54",\
"55",\
"56",\
"57",\
"58",\
"59",\
"60",\
"61",\
"62",\
"63",\
"64",\
"65",\
"66",\
"67",\
"68",\
"69",\
"70",\
"71",\
"72",\
"73",\
"74",\
"75",\
"76",\
"77",\
"78",\
"79",\
"80",\
"81",\
"82",\
"83",\
"84",\
"85",\
"86",\
"87",\
"88",\
"89",\
"90",\
"91",\
"92",\
"93",\
"94",\
"95",\
"96",\
"97",\
"98",\
"99",\
"100",\
"101",\
"102",\
"103",\
"104",\
"105",\
"106",\
"107",\
"108",\
"109",\
"110",\
"111",\
"112",\
"113",\
"114",\
"115",\
"116",\
"117",\
"118",\
"119",\
"120",\
"121",\
"122",\
"123",\
"124",\
"125",\
"126",\
"127",\
"128",\
"129",\
"130",\
"131",\
"132",\
"133",\
"134",\
"135",\
"136",\
"137",\
"138",\
"139",\
"140",\
"141",\
"142",\
"143",\
"144",\
"145",\
"146",\
"147",\
"148",\
"149",\
"150",\
"151",\
"152",\
"153",\
"154",\
"155",\
"156",\
"157",\
"158",\
"159",\
"160",\
"161",\
"162",\
"163",\
"164",\
"165",\
"166",\
"167",\
"168",\
"169",\
"170",\
"171",\
"172",\
"173",\
"174",\
"175",\
"176",\
"177",\
"178",\
"179",\
"180",\
"181",\
"182",\
"183",\
"184",\
"185",\
"186",\
"187",\
"188",\
"189",\
"190",\
"191",\
"192",\
"193",\
"194",\
"195",\
"196",\
"197",\
"198",\
"199",\
"200",\
"201",\
"202",\
"203",\
"204",\
"205",\
"206",\
"207",\
"208",\
"209",\
"210",\
"211",\
"212",\
"213",\
"214",\
"215",\
"216",\
"217",\
"218",\
"219",\
"220",\
"221",\
"222",\
"223",\
"224",\
"225",\
"226",\
"227",\
"228",\
"229",\
"230",\
"231",\
"232",\
"233",\
"234",\
"235",\
"236",\
"237",\
"238",\
"239",\
"240",\
"241",\
"242",\
"243",\
"244",\
"245",\
"246",\
"247",\
"248",\
"249",\
"250",\
"251",\
"252",\
"253",\
"254",\
"Unknown Country"\
};
/*char *copier[]={"Z64","Doctor V64"};
*/register long x,y,z;
char romname[4096];
char romheader[16];/*
unsigned long romsize;
*/char buf[32768];/*,buf2[4096];*/
char fdsbuf[66000];/*
*/unsigned long hsize=0;
char header[512];
/*int swapped=0;*/
FILE *fh;
unsigned long chksum;
//unsigned char header2[]={0x01,0x2A,0x4E,0x49,0x4E,0x54,0x45,0x4E,0x44,0x4F,0x2D,0x48,0x56,0x43,0x2A};

if(option==DBNFO)
{
printf("\nNintendo Entertainment System/NES\n\
Database: %ld known ROMs in nes_db.h (%+ld)\n",(long)(sizeof(ROM_LIST)/sizeof(ROM_TYPE)),(long)(sizeof(ROM_LIST)/sizeof(ROM_TYPE))-atol(&option2[16]));

	return(sizeof(ROM_LIST)/sizeof(ROM_TYPE));
}
if(option==DBNFO2)
{
printf("\nNintendo Entertainment System/NES\n");

for(x=0;x<sizeof(ROM_LIST)/sizeof(ROM_TYPE);x++)
	printf("{0x%08lx,\"%s\",%d,%d,\"%s\"},\n",ROM_LIST[x].chksum,ROM_LIST[x].name,ROM_LIST[x].country,ROM_LIST[x].maker,ROM_LIST[x].date);
return(0);
}
                   
strcpy(romname,mkines(name));

/*
if(option==NFO)
{
//fds
	strcpy(buf,romname);
	strupr(buf);
	if(!strcmp(&buf[strlen(buf)-4],".FDS")&&(fsize(romname,0)%65500)==0)
	{
		for(x=0;x<(fsize(romname,0)/65500);x++)
		{
			fstrncpy(fdsbuf,romname,x*65500,58);
			if(memcmp(fdsbuf,header2,15))return(-1);//check header
			if(fdsbuf[56]!=2)return(-1);//invalid file number header
z=(int)fdsbuf[57];
printf("DISK '%-4s'  Side %c  Files %d  Maker $%02X  Version $%02X\n",&fdsbuf[16],(fdsbuf[21]&1)+'A',z,fdsbuf[15],fdsbuf[20]);
for(y=0;y<z;y++)
{
	
}
                        			
		}
		return(0);
	}
}
*/

//first indentify the rom as a nes rom and test for header


hsize=0;
fstrncpy(buf,romname,0,3);
if(strdcmp(buf,"NES")!=0)
{
	hsize=NESHEADER0;
	fstrncpy(buf,romname,hsize,3);
	if(strdcmp(buf,"NES")!=0){if(!option)return(-1);}
}
if(option2[0]!='?')hsize=((option2[0]=='0')?0:NESHEADER0);

strcpy(buf,strrchr(romname,'.'));
strupr(buf);
if(!strdcmp(buf,".HDR"))
{
//only a pasofami .HDR file
	hsize=0;
//	option=NFO;
}




switch(option)
{
//case PAD:
//	strcpy(romname,fmkrom(romname,hsize));
//	strcpy(buf,romname);
//	fpad(buf,hsize);
//break;

case FFE:
	strcpy(buf,mkines(romname));
	buf[strcspn(buf,".")+1]=0;
	strcat(buf,isstrlwr(buf)?"ffe":"FFE");

	memset(header,0,sizeof(header));
	header[1]=((fsize(romname,hsize)/8192)/256);
	header[0]=((fsize(romname,hsize)/8192)-(header[1]*256));
	                
        if(!(fh=fopen(buf,"wb")))return(-1);
        fwrite(header,sizeof(header),1,fh);
	fclose(fh);
        
	fcopy3(romname,hsize,fsize(romname,hsize),buf,"ab");
break;

case INES:
	strcpy(buf,mkines(romname));
	buf[strcspn(buf,".")+1]=0;
	strcat(buf,isstrlwr(buf)?"nes":"NES");

	fcopy3(romname,hsize,fsize(romname,hsize),buf,"wb");
break;

case INESHD:
/*	if(option2[16]!=0&&!access(&option2[16],F_OK))
	{
#define START 0
		fstrncpy(buf,&option2[16],START,(sizeof(buf)<fsize(&option2[16],0))?sizeof(buf):fsize(&option2[16],0));		
		if(swapped!=0)fswap(buf,0,0x01000-0x040);
		fhexdump(buf,0,0x01000-0x040);
		fstrncpy(romname,buf,N64START+hsize+0x040,0x01000-0x040);
	}
	else
	{
		strcpy(buf,romname);
		buf[strcspn(buf,".")+1]=0;
		strcat(buf,isstrlwr(buf)?"bot":"BOT");
		fcopy3(romname,N64START+hsize+0x040,0x01000-0x040,buf,"wb");
		if(swapped!=0)fswap(buf,0,fsize(buf,0));
	}*/
	strcpy(buf,mkines(romname));
	buf[strcspn(buf,".")+1]=0;
	strcat(buf,isstrlwr(buf)?"hdr":"HDR");

	fcopy3(romname,hsize,16,buf,"wb");
break;

case PASO:
	strcpy(buf,mkines(romname));
	buf[strcspn(buf,".")+1]=0;
	strcat(buf,isstrlwr(buf)?"prm":"PRM");
	fcopy3(romname,0,16,buf,"wb");
/*
char *WriteOutPRM(char *Name,byte *Header,byte *Data)
{
//                            0123456789ABCDEF
  static char ROMType[16]  = "  T N           ";
  static char VROMType[16] = "  T T           ";
  static char GfxType[16]  = "  C N           ";

  char S[512];
  FILE *F;
  int J;

  strncpy(S,Name,511);S[511]='\0';
  if(!(F=fopen(ChangeExt(S,".prm"),"wb")))
    return("[Couldn't write .PRM]");

#define NES_ROMBanks(Header)  Header[4]
#define NES_VROMBanks(Header) Header[5]
#define NES_ROMSize(Header)   ((int)NES_ROMBanks(Header)<<14)
#define NES_VROMSize(Header)  ((int)NES_VROMBanks(Header)<<13)
#define NES_Mapper(Header)    ((Header[6]>>4)|(Header[7]&0xF0))
#define NES_Mirroring(Header) (Header[6]&0x01)
#define NES_Battery(Header)   (Header[6]&0x02)
#define NES_Trainer(Header)   (Header[6]&0x04)
#define NES_4Screens(Header)  (Header[6]&0x08)
#define NES_VSSystem(Header)  (Header[7]&0x01)

  fprintf
  (
    F,"%c%c%c%c%c %c%c%c%c%c%c%c%c%c %c%c         %c%02s%c%c\015\n",
    NES_Mirroring(Header)? 'V':'H', 
    ROMType[NES_Mapper(Header)&15], 
    VROMType[NES_Mapper(Header)&15],
    ' ',                            
    GfxType[NES_Mapper(Header)&15], 
    ' ',                            
    ' ',                            
    ' ',                            
    ' ',                            
    'S',                            
    'L',                            
    'R',                            
    ' ',                            
    NES_Battery(Header)? 'E':' ',   
    'S',                            
    NES_Mapper(Header)? 'M':' ',    
    'X',                            
    "02",                           
    '2',                            
    'A'                             
  );
  fprintf(F,"1234567890123456789012345678901234\015\n\032");
  fclose(F);

  if(NES_Trainer(Header))
  {
    if(F=fopen(ChangeExt(S,".700"),"wb"))
    {
      J=(fwrite(Data,1,512,F)==512);
      fclose(F);
      if(!J) return("[Error writing .700]");
    }
    else return("[Couldn't write .700]");
    Data+=0x200;
  }

  J=NES_ROMSize(Header);
  if(F=fopen(ChangeExt(S,".prg"),"wb"))
  {
    J=(fwrite(Data,1,J,F)==J);
    fclose(F);
    if(!J) return("[Error writing .PRG]");
  }
  else return("[Couldn't write .PRG]");

  Data+=NES_ROMSize(Header);
  J=NES_VROMSize(Header);
  if(F=fopen(ChangeExt(S,".chr"),"wb"))
  {
    J=(fwrite(Data,1,J,F)==J);
    fclose(F);
    if(!J) return("[Error writing .CHR]");
  }
  else return("[Couldn't write .CHR]");

  return(NULL);
}

*/




break;



case FDS:
//IS fds?
	if(fsize(romname,hsize)<262192)return(-1);//too small

	for(x=0;x<4;x++)
	{
		fstrncpy(fdsbuf,romname,(fsize(romname,0)-262192)+x*65500,65500);
		if(x)y=strdcmp(buf,&fdsbuf[16]);
		else
		{
			strcpy(buf,&fdsbuf[16]);
			y=0;
		}
}
//FILE *FIn,*FOut;
//  unsigned char *Buf,Name[4];
//  int J,I,NewGame;
/*
  for(J=0;J<4;J++)
  {
    printf("Disk %d: READ:",J);
    if(fread(Buf,1,65500,FIn)!=65500) break;

    if(J) NewGame=memcmp(Name,Buf+16,4);
    else
    {
      memcpy(Name,Buf+16,4);
      NewGame=0;
    }

    printf("OK TEST1:");
    if(Buf[0]!=1) break;
    printf("OK TEST2:");
    if(Buf[56]!=2) break;
    printf("OK TEST3:");
    if(Buf[58]!=3) break;
    printf("OK SIDE:");
    if(!NewGame&&(Buf[21]!=(J&1))) break;

    printf("OK WRITE:");
    if(fwrite(Buf,1,65500,FOut)!=65500) break;

    puts(NewGame? "NEW GAME?":"OK");
  }

  fclose(FIn);
  fclose(FOut);
*/
	if(x<4)return(-1);
	return(0);
break;

case NFO:
	fhexdump(romname,NESSTART+hsize,sizeof(romheader));
	printf("\n");
	printf("Nintendo Entertainment System/NES\n");
	printf("%s\n",(!hsize)?"?":"? (uses header)");//pasofami

chksum=neschksum(romname,hsize);
//chksum=0x0147766c;
x=0;
for(y=0;y<sizeof(ROM_LIST)/sizeof(ROM_TYPE);y++)
{
	for(z=-255;z<=255;z++)
	{
		if(chksum+z==ROM_LIST[y].chksum)
		{
			x=y;
			break;
		}
	}
	if(chksum+z==ROM_LIST[y].chksum)break;
}


	printf("%s\n",ROM_LIST[x].name);

	printf("%s\n",maker[ROM_LIST[x].maker]);
	printf("%s\n",country[ROM_LIST[x].country]);


	printf("%ld bytes (%.4f MBit)\n",fsize(romname,hsize),(float)fsize(romname,hsize)/MBIT);


printf("\n");

printf("Date: %s\n",ROM_LIST[x].date);
y=x;
	if((x=fpad(romname,hsize,"rb"))!=-1)
	{
		if(!x)printf("Padded: No\n");
		else printf("Padded: Maybe, %ld bytes (%.4f MBit)\n",x,(float)x/MBIT);
	}
        printf("Internal Size: %.4f MBit\n",((float) ((int)fgetc2(romname,NESSTART+hsize+4)<<14)/MBIT)+((float)((int) fgetc2(romname,NESSTART+hsize+5)<<13)/MBIT));
        printf("Internal PRG Size: %.4f MBit\n",(float) ((int)fgetc2(romname,NESSTART+hsize+4)<<14)/MBIT);
        printf("Internal CHR/RAM Size: %.4f MBit\n",(float)((int) fgetc2(romname,NESSTART+hsize+5)<<13)/MBIT);




	x=fgetc2(romname,NESSTART+hsize+6);

        printf("Memory mapper: %d\n",(int) ((x >> 4) | (fgetc2(romname,NESSTART+hsize+7) & 0xf0)));

	printf("Mirroring: %s\n",(x& 0x01)?"vertical":"horizontal");
	printf("Save RAM: %s\n",(x& 0x02)?"yes":"no");
	printf("512-byte trainer: %s\n",(x& 0x04)?"yes":"no");
	printf("Four-screen mirroring: %s\n",(x& 0x08)?"yes":"no");
	printf("VSSystem: %s\n",(fgetc2(romname,NESSTART+hsize+7)& 0x01)?"yes":"no");

//remember the unused "y"
//	printf("Pseudo Checksum: %08lx\n",(unsigned long)neschksum(romname,hsize));
	printf("Pseudo CheckSum: %08lx %s %08lx\n",(unsigned long)neschksum(romname,hsize),((z&0x0ff)==0)?"ok":"bad",ROM_LIST[y].chksum);

	printf("\n");
break;

default:
break;
}
return(0);
}
