#define SNESSTART 32688
unsigned long sneschksum(char *name,long hirom,long hsize)
{
FILE *fh;
unsigned long i;
char *buf;
int power2 = 0;
 int size;
    unsigned long remainder;
    unsigned long sum1 = 0;
    unsigned long sum2 = 0;

fhexdump(name,SNESSTART+hirom+hsize+44,4);
if(!(fh=fopen(name,"r+b")))return(-1);
size=fsize(name,hsize);

    while(size>>=1)power2++;
    size=1<<power2;
	 remainder = fsize(name,hsize) - size;

	if(!(buf=(char *)malloc((fsize(name,hsize)+2)*sizeof(char))))
		{
			fclose(fh);
        		return(-1);
		}
fseek(fh,hsize,SEEK_SET);
		if(!fread(buf,fsize(name,hsize),1,fh))
		{
			fclose(fh);
			free(buf);
			return(-1);
}

    for(i=0;i<size;i++)sum1+=buf[i]&0xff;

    for(i=0;i<(int)remainder;i++)sum2+=buf[size+i]&0xff;

    if(remainder)sum1+=sum2*(size/remainder);
free(buf);

sum1&=0xffff;
sum2=sum1&0xff;
sum1=sum1>>8;
sum2=sum2<<8;
sum1+=sum2;

	fseek(fh,SNESSTART+hirom+hsize+44, SEEK_SET);
	fputc((0xffff-sum1) >> 8, fh);
	fputc((0xffff-sum1) & 0xFF, fh);
	fputc(sum1 >> 8, fh);
	fputc(sum1 & 0xFF, fh);
fclose(fh);

fhexdump(name,SNESSTART+hirom+hsize+44,4);
printf("\n");
return(sum1);
}

char *joinsnes(char *name,long hsize)
{
char buf[4096];
strcpy(buf,name);
name[strcspn(name,".")+1]=0;
strcat(name,isstrlwr(name)?"tmp":"TMP");
fcopy(buf,0,name,"wb");
for(;;)
{
//printf("%s\n",buf);
	if(!hsize)buf[strcspn(buf,".")-1]++;
	else buf[strcspn(buf,".")+1]++;
	if(fcopy(buf,hsize,name,"ab")==-1)break;
}
return(name);
}
#define MBIT 131072


//options

#define NFO	11//show rom info
#define JOIN	20
#define SPLIT	1//split
#define CRK	2//crack
#define PNF	3//pal ntsc fix
#define SLW	4//slowrom
#define PAD	6//fix size
#define MGH	7//convert to Multi Game Hunter (binary)
#define SMC	8//convert to Super Magicom
#define FIG	9//convert to Super ProFighter
#define CHK	5//fix checksum
#define SWC	10//convert to Super Wild Card
#define COL	12
#define NAME	55//change name
#define GD3	13	//convert to Game Doctor 3/6/7
#define GDF	14	//fix Game Doctor 3/6/7 savegame problem

#define GAMEGENIE 111

//this single routine does all the supernintendo stuff

int supernintendo(char *name,int option,char *option2)
{
//option2[0] = header: '1'=yes, ' '=no, '?'=unknown
//option2[1] = hirom: '1'=yes, ' '=no, '?'=unknown
//&option2[16] = string


#define SNESHEADER0 512
#define SNESHIROM 32768



char *maker[]={"?",\
"Nintendo",\
"2",\
"Imagineer-Zoom",\
"4",\
"Zamuse",\
"Falcom",\
"7",\
"Capcom",\
"HOT-B",\
"Jaleco",\
"Coconuts",\
"Coconuts",\
"13",\
"Technos",\
"Pack-In-Video",\
"16",\
"Starfish",\
"Gremlin Graphics",\
"Electronic Arts",\
"20",\
"Cobra Team",\
"Human",\
"KOEI",\
"Hudson Soft",\
"Yanoman",\
"Yanoman",\
"27",\
"Tecmo Products",\
"29",\
"Open System",\
"Virgin Games",\
"KSS",\
"Sunsoft",\
"Pow",\
"Micro World",\
"36",\
"37",\
"Enix",\
"Loriciel/Electro Brain",\
"Kemco",\
"Seta",\
"42",\
"43",\
"44",\
"Visit",\
"46",\
"47",\
"Viacom New Media",\
"Carrozzeria",\
"Dynamic",\
"?" /*0x33*/,\
"Magifact",\
"Hect",\
"54",\
"55",\
"56",\
"57",\
"58",\
"Arcade Zone",\
"Empire Software",\
"Loriciel",\
"62",\
"63",\
"Seika",\
"Ubi Soft",\
"66",\
"67",\
"68",\
"69",\
"System 3",\
"Spectrum HoloByte",\
"72",\
"Irem",\
"74",\
"Raya Systems",\
"Renovation Products*",\
"Malibu Games",\
"78",\
"U.S. Gold",\
"Absolute",\
"Acclaim",\
"Activision",\
"American Sammy",\
"Gametek",\
"Hi Tech Entertainment",\
"LJN",\
"87",\
"88",\
"89",\
"Mindscape",\
"91",\
"92",\
"Tradewest",\
"94",\
"American Softworks",\
"Titus",\
"Virgin Interactive Entertainment",\
"Maxis*",\
"Origin/FCI/Pony Canyon",\
"100",\
"101",\
"102",\
"Ocean",\
"104",\
"Electronic Arts",\
"106",\
"Laserbeam",\
"108",\
"109",\
"Elite",\
"Electro Brain",\
"Infogrames",\
"Interplay",\
"LucasArts",\
"Parker Brothers",\
"Konami",\
"STORM*",\
"118",\
"119",\
"T*HQ",\
"Accolade",\
"Triffix",\
"123",\
"Microprose",\
"125",\
"126",\
"Kemco",\
"Misawa",\
"Teichio",\
"Namco",\
"Lozc",\
"KOEI",\
"133",\
"T.I.M.",\
"135",\
"Datam Polystar",\
"137",\
"138",\
"Bullet-Proof Software",\
"Vic Tokai",\
"141",\
"Character Soft",\
"I'Max",\
"Takara",\
"Chun Soft",\
"Video System",\
"Bec",\
"148",\
"Varie",\
"150",\
"Kaneco",\
"152",\
"Pack-In-Video",\
"Nichibutsu",\
"Tecmo",\
"Imagineer",\
"157",\
"158",\
"159",\
"Telenet",\
"Hori",\
"162",\
"163",\
"Konami",\
"K. Amusement Leasing Co.",\
"166",\
"Takara",\
"168",\
"Technos",\
"JVC",\
"171",\
"TOEI Animation",\
"Toho",\
"174",\
"Namco",\
"176",\
"ASCII",\
"Bandai",\
"179",\
"Enix",\
"181",\
"Halken",\
"183",\
"184",\
"185",\
"Culture Brain",\
"Sunsoft",\
"Toshiba EMI",\
"Sony Imagesoft",\
"190",\
"Sammy",\
"Taito",\
"193",\
"Kemco",\
"Square",\
"Tokuma Soft",\
"Data East",\
"Tonkinhouse",\
"199",\
"KOEI",\
"201",\
"Konami",\
"NTVIC",\
"204",\
"Meldac",\
"Pony Canyon",\
"Sotsu Agency/Sunrise",\
"Disco/Taito",\
"Sofel",\
"Quest",\
"Sigma*",\
"212",\
"213",\
"Naxat",\
"215",\
"Capcom",\
"Banpresto",\
"Tomy",\
"Acclaim",\
"220",\
"NCS",\
"Human",\
"Altron",\
"Jaleco",\
"225",\
"Yutaka",\
"227",\
"T&Esoft",\
"Epoch",\
"230",\
"Athena",\
"Asmik",\
"Natsume",\
"King Records",\
"Atlus",\
"Sony Music Entertainment",\
"237",\
"IGS",\
"239",\
"240",\
"Motown Software",\
"Left Field Entertainment",\
"Beam Software/Extreme",\
"TecMagik",\
"245",\
"246",\
"247",\
"248",\
"Cybersoft",\
"250",\
"251",\
"252",\
"253",\
"Davidson",\
"Unknown Maker"};
char *country[]={\
"Japan",\
"U.S.A.",\
"Europe, Australia, Oceania and Asia",\
"Sweden",\
"Finland",\
"Denmark",\
"France",\
"Holland",\
"Spain",\
"Germany, Austria and Switzerland",\
"Italy",\
"Hong Kong and China",\
"Indonesia",\
"Korea",\
"14",\
"15",\
"16",\
"17",\
"18",\
"19",\
"20",\
"21",\
"22",\
"23",\
"24",\
"25",\
"26",\
"27",\
"28",\
"29",\
"30",\
"31",\
"32",\
"33",\
"34",\
"35",\
"36",\
"37",\
"38",\
"39",\
"40",\
"41",\
"42",\
"43",\
"44",\
"45",\
"46",\
"47",\
"48",\
"49",\
"50",\
"51",\
"52",\
"53",\
"54",\
"55",\
"56",\
"57",\
"58",\
"59",\
"60",\
"61",\
"62",\
"63",\
"64",\
"65",\
"66",\
"67",\
"68",\
"69",\
"70",\
"71",\
"72",\
"73",\
"74",\
"75",\
"76",\
"77",\
"78",\
"79",\
"80",\
"81",\
"82",\
"83",\
"84",\
"85",\
"86",\
"87",\
"88",\
"89",\
"90",\
"91",\
"92",\
"93",\
"94",\
"95",\
"96",\
"97",\
"98",\
"99",\
"100",\
"101",\
"102",\
"103",\
"104",\
"105",\
"106",\
"107",\
"108",\
"109",\
"110",\
"111",\
"112",\
"113",\
"114",\
"115",\
"116",\
"117",\
"118",\
"119",\
"120",\
"121",\
"122",\
"123",\
"124",\
"125",\
"126",\
"127",\
"128",\
"129",\
"130",\
"131",\
"132",\
"133",\
"134",\
"135",\
"136",\
"137",\
"138",\
"139",\
"140",\
"141",\
"142",\
"143",\
"144",\
"145",\
"146",\
"147",\
"148",\
"149",\
"150",\
"151",\
"152",\
"153",\
"154",\
"155",\
"156",\
"157",\
"158",\
"159",\
"160",\
"161",\
"162",\
"163",\
"164",\
"165",\
"166",\
"167",\
"168",\
"169",\
"170",\
"171",\
"172",\
"173",\
"174",\
"175",\
"176",\
"177",\
"178",\
"179",\
"180",\
"181",\
"182",\
"183",\
"184",\
"185",\
"186",\
"187",\
"188",\
"189",\
"190",\
"191",\
"192",\
"193",\
"194",\
"195",\
"196",\
"197",\
"198",\
"199",\
"200",\
"201",\
"202",\
"203",\
"204",\
"205",\
"206",\
"207",\
"208",\
"209",\
"210",\
"211",\
"212",\
"213",\
"214",\
"215",\
"216",\
"217",\
"218",\
"219",\
"220",\
"221",\
"222",\
"223",\
"224",\
"225",\
"226",\
"227",\
"228",\
"229",\
"230",\
"231",\
"232",\
"233",\
"234",\
"235",\
"236",\
"237",\
"238",\
"239",\
"240",\
"241",\
"242",\
"243",\
"244",\
"245",\
"246",\
"247",\
"248",\
"249",\
"250",\
"251",\
"252",\
"253",\
"254",\
"Unknown Country"\
};


char *romtype2[] = {\
"+DSP1",\
"+SuperFX",\
"+OBC1",\
"+SA-1",\
"+S-DD1",\
"+5",\
"+6",\
"+7",\
"+8",\
"+9",\
"+10",\
"+11",\
"+12",\
"+13",\
"+14",\
"+Custom"\
};
                                
char *romtype[]={\
"ROM",\
"ROM+RAM",\
"ROM+RAM+BAT",\
};
/*
"3",\
"4",\
"5",\
"6",\
"7",\
"8",\
"9",\
"10",\
"11",\
"12",\
"13",\
"14",\
"15",\
"16",\
"17",\
"18",\
"ROM and Super FX micro chip",\
"20",\
"21",\
"22",\
"23",\
"24",\
"25",\
"26",\
"27",\
"28",\
"29",\
"30",\
"31",\
"32",\
"33",\
"34",\
"35",\
"36",\
"37",\
"38",\
"39",\
"40",\
"41",\
"42",\
"43",\
"44",\
"45",\
"46",\
"47",\
"48",\
"49",\
"50",\
"51",\
"52",\
"ROM, RAM, Save RAM and SA-1",\
"54",\
"55",\
"56",\
"57",\
"58",\
"59",\
"60",\
"61",\
"62",\
"63",\
"64",\
"65",\
"66",\
"67",\
"68",\
"69",\
"70",\
"71",\
"72",\
"73",\
"74",\
"75",\
"76",\
"77",\
"78",\
"79",\
"80",\
"81",\
"82",\
"83",\
"84",\
"85",\
"86",\
"87",\
"88",\
"89",\
"90",\
"91",\
"92",\
"93",\
"94",\
"95",\
"96",\
"97",\
"98",\
"99",\
"100",\
"101",\
"102",\
"103",\
"104",\
"105",\
"106",\
"107",\
"108",\
"109",\
"110",\
"111",\
"112",\
"113",\
"114",\
"115",\
"116",\
"117",\
"118",\
"119",\
"120",\
"121",\
"122",\
"123",\
"124",\
"125",\
"126",\
"127",\
"128",\
"129",\
"130",\
"131",\
"132",\
"133",\
"134",\
"135",\
"136",\
"137",\
"138",\
"139",\
"140",\
"141",\
"142",\
"143",\
"144",\
"145",\
"146",\
"147",\
"148",\
"149",\
"150",\
"151",\
"152",\
"153",\
"154",\
"155",\
"156",\
"157",\
"158",\
"159",\
"160",\
"161",\
"162",\
"163",\
"164",\
"165",\
"166",\
"167",\
"168",\
"169",\
"170",\
"171",\
"172",\
"173",\
"174",\
"175",\
"176",\
"177",\
"178",\
"179",\
"180",\
"181",\
"182",\
"183",\
"184",\
"185",\
"186",\
"187",\
"188",\
"189",\
"190",\
"191",\
"192",\
"193",\
"194",\
"195",\
"196",\
"197",\
"198",\
"199",\
"200",\
"201",\
"202",\
"203",\
"204",\
"205",\
"206",\
"207",\
"208",\
"209",\
"210",\
"211",\
"212",\
"213",\
"214",\
"215",\
"216",\
"217",\
"218",\
"219",\
"220",\
"221",\
"222",\
"223",\
"224",\
"225",\
"226",\
"ROM, RAM, and GameBoy Guts",\
"228",\
"229",\
"230",\
"231",\
"232",\
"233",\
"234",\
"235",\
"236",\
"237",\
"238",\
"239",\
"240",\
"241",\
"242",\
"243",\
"244",\
"245",\
"ROM and DSP2 micro chip",\
"246",\
"247",\
"248",\
"249",\
"250",\
"251",\
"252",\
"253",\
"254",\
""\
};
*/
char *copier[]={"Multi Game*/MGD2/MGH/RAW/Professor SF(2) Game Doctor SF3/6/7","Super Magicom/SMC/*Pro Fighter*/(all)FIG/Super Wild Card*/(all)SWC","*Pro Fighter*/(all)FIG/Super Wild Card*/(all)SWC/HiROM"};
register long x;
unsigned int y;
char mgh[32];
char *romname;
char romheader[48];
char buf[32768],buf2[4096];
unsigned long hsize;
char header[512];
long hirom=0;
FILE *fh;
int r,g,b;

romname=name;

if(option==COL)
{
/*The Nintendo Super Famicom is capable of displaying 256 colours from a
palette of 32,768. These 256 colours are split into 8 palettes of 32 colours
each.

To change the colours the following needs to be done:

Loading the palette control register ($2121) with the colour number you wish
to change (0-255, 0=background).
Then load the colour into the palette data register first the low 8 bits,
followed by the high 7 bits (this gives you the maximum 32768 colours
possible $0000-$7fff).

Colour data is made up of 3 components (Red,Green,Blue) each of 5 bits (The
Amiga uses exactly the same system, but only using 4 bits per component).
Saying that, Nintendo being the stupid japanese idiots they are decided that
R,G,B wasn't alphabetically correct and so opted to store the bits as B,G,R.

                      00000 00000 00000
                      \   / \   / \   /
                       \ /   \ /   \ /
                        B     G     R

Examples:
~~~~~~~~~
         11111 00000 00000 = $7C00 (Bright Blue)
         00000 11111 00000 = $03E0 (Bright Green)
         00000 00000 11111 = $001F (Bright Red)
         00000 00000 00000 = $0000 (Black)
         11111 11111 11111 = $7FFF (White)

Easy, isn't it?? (But remember to load the lowest 8 bits first, then the top
                  7 bits).
*/


//strcpy(romname,name);
sscanf(romname,"%x",&y);

	r=(y&0xff0000)/0x10000;
	g=(y&0xff00)/0x100;
	b=y&0xff;

	printf("0x%02x%02x%02x (html) == ",r,g,b);
	
	r=(r*0x1f)/0xff;
	g=(g*0x1f)/0xff;
	b=(b*0x1f)/0xff;

	y=b;
	y=y<<5;
	y=y+g;
	y=y<<5;
	y=y+r;
	
	printf("0x%02x%02x (snes)\n",y&0xff,(y&0x7f00)/0x100);

sscanf(romname,"%x",&y);

	if((unsigned long)y<0xff7f+1)
	{
	printf("0x%04x (snes) == ",y&0xff7f);

	y=((y&0x7f)*0x100)+((y&0xff00)/0x100);

	r=y&0x1f;
	g=(y&(0x1f<<5))>>5;
	b=(y&(0x1f<<10))>>10;

	r=r*0xff/0x1f;
	g=g*0xff/0x1f;
	b=b*0xff/0x1f;
	
	printf("0x%02x%02x%02x (html)\n",r,g,b);
	}
	printf("\n");
	return(0);
}

//first indentify the rom as a super nintendo/sfamicon rom and test for
//header and hirom

hirom=hsize=0;
if(fgetc2(romname,SNESSTART+hirom+hsize+44)+fgetc2(romname,SNESSTART+hirom+hsize+44+1)*256+fgetc2(romname,SNESSTART+hirom+hsize+44+2)+fgetc2(romname,SNESSTART+hirom+hsize+44+3)*256!=65535)
{
	hirom=SNESHIROM;hsize=SNESHEADER0;
	if(fgetc2(romname,SNESSTART+hirom+hsize+44)+fgetc2(romname,SNESSTART+hirom+hsize+44+1)*256+fgetc2(romname,SNESSTART+hirom+hsize+44+2)+fgetc2(romname,SNESSTART+hirom+hsize+44+3)*256!=65535)
	{
		hirom=0;hsize=SNESHEADER0;
		if(fgetc2(romname,SNESSTART+hirom+hsize+44)+fgetc2(romname,SNESSTART+hirom+hsize+44+1)*256+fgetc2(romname,SNESSTART+hirom+hsize+44+2)+fgetc2(romname,SNESSTART+hirom+hsize+44+3)*256!=65535)
		{
			hirom=SNESHIROM;hsize=0;
			if(fgetc2(romname,SNESSTART+hirom+hsize+44)+fgetc2(romname,SNESSTART+hirom+hsize+44+1)*256+fgetc2(romname,SNESSTART+hirom+hsize+44+2)+fgetc2(romname,SNESSTART+hirom+hsize+44+3)*256!=65535){if(!option)return(-1);}
		}
	}
}
if(fsize(romname,hsize)<32768){if(!option)return(-1);}


if(option2[0]!='?')hsize=((option2[0]=='0')?0:SNESHEADER0);
if(option2[1]!='?')hirom=((option2[1]=='0')?0:SNESHIROM);

if(!(romname=strrchr(name,'/')))romname=name;
else romname++;
//strcpy(romname,name);
strcpy(buf,name);
buf[strlen(buf)-strlen(romname)]=0;
chdir(buf);

switch(option)
{
case SPLIT:
	if(!hsize)
	{
		strcpy(romname,joinsnes(romname,hsize));
	
		strcpy(buf,isstrlwr(romname)?"sf":"SF");
		strcpy(buf2,romname);
		buf2[strcspn(buf2,".")]=0;
		strcat(buf2,"________");
		strcat(buf,buf2);
		buf[7]=isstrlwr(buf)?'a':'A';
		buf[8]=0;
		sprintf(buf2,"%s.%03lu",buf,(unsigned long)fsize(romname,hsize)/MBIT);

		for(x=0;x<(fsize(romname,hsize)/(4*MBIT));x++)
		{
			fcopy3(romname,x*4*MBIT,4*MBIT,buf2,"wb");
			buf2[strcspn(buf2,".")-1]++;
		}                
		if((fsize(romname,hsize)%(4*MBIT))!=0)
		fcopy3(romname,(x+1)*4*MBIT,(fsize(romname,hsize)%(4*MBIT)),buf2,"wb");

		remove(romname);
	}
	else
	{
		memset(header,0,sizeof(header));
		fstrncpy(header,romname,0,sizeof(header));

		strcpy(buf,romname);
		buf[strcspn(buf,".")+1]=0;
		strcat(buf,isstrlwr(buf)?"tmp":"TMP");
		fcopy3(romname,hsize,fsize(romname,hsize),buf,"wb");

		strcpy(buf2,romname);
		buf2[strcspn(buf2,".")+1]=0;
		strcat(buf2,"1");

		for(x=0;x<fsize(romname,hsize)/(4*MBIT);x++)
		{
			header[1]=(((4*MBIT)/8192)/256);
			header[0]=(((4*MBIT)/8192)-(header[1]*256));
			
		        if(!(fh=fopen(buf2,"wb")))return(-1);
			fwrite(header,sizeof(header),1,fh);
		        fclose(fh);
			        
			fcopy3(buf,x*4*MBIT,4*MBIT,buf2,"ab");
			
			buf2[strcspn(buf2,".")+1]++;
		}
		if((fsize(romname,hsize)%(4*MBIT))!=0)
		{
			header[1]=(((fsize(buf,0)%(4*MBIT))/8192)/256);
			header[0]=(((fsize(buf,0)%(4*MBIT))/8192)-(header[1]*256));
			
		        if(!(fh=fopen(buf2,"wb")))return(-1);
			fwrite(header,sizeof(header),1,fh);
		        fclose(fh);
		        
			fcopy3(buf,((x+1)*4*MBIT),(fsize(buf,0)%(4*MBIT)),buf2,"ab");
		}
		remove(buf);
	}
break;

case JOIN:
	if(!hsize)supernintendo(name,MGH,option2);
	else supernintendo(name,SMC,option2);
break;

case GAMEGENIE:
	return(gamegenie(romname,(!hirom)?SNESLO:SNESHI,&option2[16],hsize));
break;

case CRK:
/*
	freplace(romname,'*',"\x8f**\x70\xcf**\x70\xd0",6,"\xad\x3f\x21\x89\x10\xea\xea",7,hsize);
	freplace(romname,'*',"\xad\x3f\x21\x89\x10\xd0",6,"\xad\x3f\x21\x89\x10\xea\xea",7,hsize);
	freplace(romname,'*',"\xad\x3f\x21\x89\x10\xd0",6,"\xad\x3f\x21\x89\x10\xea\xea",7,hsize);
	8F/9F xx xx 70 CF/DF xx xx 70 D0
becomes:8F/9F xx xx 70 CF/DF xx xx 70 EA EA
becomes:8F/9F xx xx 70 CF/DF xx xx 70 80 //if saveramsize==64

	8F/9F xx xx 30/31/32/33 CF/DF xx xx 30/31/32/33 D0
becomes:8F/9F xx xx 30/31/32/33 CF/DF xx xx 30/31/32/33 80

	8F/9F xx xx 30/31/32/33 CF/DF xx xx 30/31/32/33 F0
becomes:8F/9F xx xx 30/31/32/33 CF/DF xx xx 30/31/32/33 EA EA

	8F/9F xx xx 30/31/32/33 AF xx xx 30/31/32/33 C9 xx xx D0
becomes:8F/9F xx xx 30/31/32/33 AF xx xx 30/31/32/33 C9 xx xx 80
*/
break;

case PNF:
	freplace(romname,'*',"\xad\x3f\x21\x89\x10\xd0",6,"\xad\x3f\x21\x89\x10\xea\xea",7,hsize);
	freplace(romname,'*',"\xad\x3f\x21\x89\x10\xf0",6,"\xad\x3f\x21\x89\x10\x80",6,hsize);

	freplace(romname,'*',"\xad\x3f\x21\x29\x10\xc9\x00\xf0",8,"\xad\x3f\x21\x29\x10\xc9\x00\xea\xea",9,hsize);
	freplace(romname,'*',"\xad\x3f\x21\x29\x10\xc9\x00\xd0",8,"\xad\x3f\x21\x29\x10\xc9\x00\x80",8,hsize);
	freplace(romname,'*',"\xad\x3f\x21\x29\x10\xc9\x10\xf0",8,"\xad\x3f\x21\x29\x10\xc9\x10\x80",8,hsize);
	freplace(romname,'*',"\xad\x3f\x21\x29\x10\xc9\x10\xd0",8,"\xad\x3f\x21\x29\x10\xc9\x10\xea\xea",9,hsize);
break;

case SLW:
	freplace(romname,'*',"\x8d\x0d\x42",3,"\x9c\x0d\x42",3,hsize);
	freplace(romname,'*',"\x8e\x0d\x42",3,"\x9c\x0d\x42",3,hsize);
	freplace(romname,'*',"\x8c\x0d\x42",3,"\x9c\x0d\x42",3,hsize);
	freplace(romname,'*',"\x8f\x0d\x42",3,"\x9c\x0d\x42",3,hsize);

	freplace(romname,'*',"\x01\x0d\x42",3,"\x00\x0d\x42",3,hsize);

//special one (used by Konami and Jaleco? sometimes)
	freplace(romname,'*',"\xa9\x01\x85\x0d",4,"\xa9\x00",2,hsize);
	freplace(romname,'*',"\xa2\x01\x86\x0d",4,"\xa2\x00",2,hsize);
	freplace(romname,'*',"\xa0\x01\x84\x0d",4,"\xa0\x00",2,hsize);
break;

case PAD:
	strcpy(buf,romname);
	fpad(joinsnes(buf,hsize),hsize,"wb");
//	remove(romname);
	rename(buf,romname);
break;

case CHK:
	sneschksum(romname,hirom,hsize);
break;

case MGH:
	strcpy(buf,isstrlwr(romname)?"sf":"SF");
	strcpy(buf2,romname);
	buf2[strcspn(buf2,".")]=0;
	strcat(buf2,"________");
	strcat(buf,buf2);
	buf[7]='_';
	buf[8]=0;
	sprintf(buf2,"%s.%03lu",buf,(unsigned long)fsize(romname,hsize)/MBIT);
	strcpy(buf,romname);
	fcopy(joinsnes(buf,hsize),hsize,buf2,"wb");
	remove(buf);

//automatically create MGH name file

	memset(mgh,0,sizeof(mgh));
	mgh[0]='M';
	mgh[1]='G';
	mgh[2]='H';
	mgh[3]=0x1a;
	mgh[31]=0xff;

	for(x=16;x<31;x++)mgh[x]=fgetc2(romname,SNESSTART+hirom+hsize+16+x);

	strcpy(buf,romname);
	buf[strcspn(buf,".")+1]=0;
	strcat(buf,isstrlwr(buf)?"mgh":"MGH");

	if(!(fh=fopen(buf,"wb")))break;
	fwrite(mgh,sizeof(mgh),1,fh);
	fclose(fh);
break;

case GD3:
	sprintf(buf,"%s%02ld",isstrlwr(romname)?"sf":"SF",(unsigned long)fsize(romname,hsize)/MBIT);
	strcpy(buf2,romname);
	buf2[strcspn(buf2,".")]=0;
	strcat(buf2,"________");
	strcat(buf,buf2);
	buf[7]='X';
	buf[8]=0;
	strcpy(buf2,buf);
	strcpy(buf,romname);
	fcopy(joinsnes(buf,hsize),hsize,buf2,"wb");
	remove(buf);
break;

case GDF:
//	if(!hsize)break;
	memset(header,0,sizeof(header));
	if(!(fh=fopen(romname,"r+b")))return(-1);
	fread(header,sizeof(header),1,fh);
	fseek(fh,0,SEEK_SET);
	header[0x10]=0x81;
	header[0x29]=0x0c;
	header[(0x29)+1]=0x0c;
	fwrite(header,sizeof(header),1,fh);
	fclose(fh);
	
break;

case SMC:
//if(hirom!=0)printf("This game might wont work with Super Magicom because its HIROM\n\n");
	memset(header,0,sizeof(header));
	header[1]=((fsize(romname,hsize)/8192)/256);
	header[0]=((fsize(romname,hsize)/8192)-(header[1]*256));
	header[8]=0xaa;
	header[9]=0xbb;
	header[10]=0x04;

	strcpy(buf,romname);
	buf[strcspn(buf,".")+1]=0;
	strcat(buf,isstrlwr(buf)?"smc":"SMC");

	if(!(fh=fopen(buf,"wb")))return(-1);
	fwrite(header,sizeof(header),1,fh);
	fclose(fh);

	strcpy(buf2,romname);
	joinsnes(buf2,hsize);
	fcopy(buf2,hsize,buf,"ab");
	remove(buf2);
break;



case FIG:	
	memset(header,0,sizeof(header));
	header[1]=((fsize(romname,hsize)/8192)/256);
	header[0]=((fsize(romname,hsize)/8192)-(header[1]*256));
	if(hirom!=0)header[3]=0x80;
/*
	for(x=1;x<((romheader[24]>0)?romheader[24]:romheader[24]+256)+2;x=x*2);
	x=x*8;
	if(!x)
	{
		header[4]=0x77;
		header[5]=0x83;
	}
	else
	{
		header[4]=0xdd;
		header[5]=0x82;
	}
	if(rom==3||rom==4||rom==5)
	{
		if(!sram(fname))
		{
			header[4]=0x47;
			header[5]=0x83;
		}
		if(sram(fname)>0)
		{
			header[4]=0xfd;
			header[5]=0x82;
		}
	}
*/
       	header[8]=0xaa;
	header[9]=0xbb;
	header[10]=0x04;

	strcpy(buf,romname);
	buf[strcspn(buf,".")+1]=0;
	strcat(buf,isstrlwr(buf)?"fig":"FIG");

	if(!(fh=fopen(buf,"wb")))return(-1);
	fwrite(header,sizeof(header),1,fh);
	fclose(fh);

	strcpy(buf2,romname);
	fcopy(joinsnes(buf2,hsize),hsize,buf,"ab");
	remove(buf2);
break;

case SWC:
	memset(header,0,sizeof(header));
	header[1]=((fsize(romname,hsize)/8192)/256);
	header[0]=((fsize(romname,hsize)/8192)-(header[1]*256));
	if(hirom!=0)header[2]=0x30;
	header[8]=0xaa;
	header[9]=0xbb;
	header[10]=0x04;

	strcpy(buf,romname);
	buf[strcspn(buf,".")+1]=0;
	strcat(buf,isstrlwr(buf)?"swc":"SWC");

	if(!(fh=fopen(buf,"wb")))return(-1);
	fwrite(header,sizeof(header),1,fh);
	fclose(fh);

	strcpy(buf2,romname);
	fcopy(joinsnes(buf2,hsize),hsize,buf,"ab");
	remove(buf2);
break;

case NAME:
	strcat(option2,"                     ");
//        strcat(option2,"\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0");
        
	fstrncpy(romname,&option2[16],SNESSTART+hirom+hsize+16,21);
	supernintendo(name,NFO,option2);
break;

case NFO:
	if(access(name,F_OK)!=0)return(0);

	fhexdump(romname,SNESSTART+hirom+hsize,sizeof(romheader));
	printf("\n");
	printf("Super Nintendo/Super Famicon\n");
        
	printf("%s\n",copier[(!hsize)?0:((!hirom)?1:2)]);

	for(x=0;x<21;x++)printf("%c",fgetc2(romname,SNESSTART+hirom+hsize+16+x));
	printf("\n");

	if(fgetc2(romname,SNESSTART+hirom+hsize+42)==0x33)
	{
		x=fgetc2(romname,SNESSTART+hirom+hsize);
		y=fgetc2(romname,SNESSTART+hirom+hsize+1);

		printf("%s\n",maker[\
((x<0x3a)?(x-0x30)*16:(x-0x37)*16)\
+\
((y<0x3a)?y-0x30:y-0x37)\
]);
	}
	else printf("%s\n",maker[fgetc2(romname,SNESSTART+hirom+hsize+42)]);
	printf("%s\n",country[fgetc2(romname,SNESSTART+hirom+hsize+41)]);

	printf("%ld bytes (%.4f MBit)\n",fsize(romname,hsize),(float)fsize(romname,hsize)/MBIT);


printf("\n");


	if((x=fpad(romname,hsize,"rb"))!=-1)
	{
		if(!x)printf("Padded: No\n");
		else printf("Padded: Maybe, %ld bytes (%.4f MBit)\n",x,(float)x/MBIT);
	}

printf("Internal Size: %.4f MBit\n",(float)(1<<(fgetc2(romname,SNESSTART+hirom+hsize+39)-7)));
	x=fgetc2(romname,SNESSTART+hirom+hsize+38);
	printf("RomType: %x %s",(int)x,(!x)?"Rom only":romtype[(x&0x0f)%3]);
	printf("%s\n",((x & 0xf) >= 3)?romtype2[(x&0xf0)>>4]:"");

	printf("RomSpeed: %s\n",(fgetc2(romname,SNESSTART+hirom+hsize+37)& 0x10)? "120ns" : "200ns");
	
	
	printf("HiROM: %s\n",(!hirom)?"No (<16MBit and/or before mid-1993)":"Yes (>=16 MBit and/or after mid-1993)");
	x=(fsize(romname,hsize)-(fsize(romname,hsize)/MBIT)*MBIT);
	if(!x)printf("Intro/Trainer: No\n");
	else printf("Intro/Trainer: Yes, %ld bytes\n",x);

	x=fgetc2(romname,SNESSTART+hirom+hsize+45);
	x=x+(fgetc2(romname,SNESSTART+hirom+hsize+44)<<8);
	x=x+fgetc2(romname,SNESSTART+hirom+hsize+47);
	x=x+(fgetc2(romname,SNESSTART+hirom+hsize+46)<<8);
	printf("CheckSum: %02x%02x, %s %x\n",fgetc2(romname,SNESSTART+hirom+hsize+46),fgetc2(romname,SNESSTART+hirom+hsize+47),(x==0xffff)?"ok":"bad",(int)x);
	printf("Complement Check: %02x%02x\n",fgetc2(romname,SNESSTART+hirom+hsize+44),fgetc2(romname,SNESSTART+hirom+hsize+45));

	y=fgetc2(romname,SNESSTART+hirom+hsize+40);


x=y?(1 << (y + 3)) * 128 : 0;
//	for(x=1;x<y+2;x=x*2);
//	x=x*8;
        if(!x)printf("Save RAM: No\n");
	else printf("Save RAM: Yes, %ld kbytes\n",(long)(x/1024));
	printf("Version: 1.%d\n",fgetc2(romname,SNESSTART+hirom+hsize+43));
	printf("\n");
break;

default:
break;
}
return(0);
}



