#ifdef LINUX

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

//#define ai 0x37b
//#define data 0x37c

char *file_name=NULL;
char write_en=0;
char test_en=0;
char verify_en=0;
char disp_on=1;
FILE *fptr;
union mix_buffer {
unsigned char buffer[32768];
unsigned short int bufferx[16384];
}mix;
unsigned short int port[2];
unsigned char port_no;
unsigned short int port_8,port_9,port_a,port_b,port_c;
unsigned char disp_buf[16];
short int i,j,page,sel,err,wv_mode;
char ch=' ';


unsigned char inportb(arg1)
{
  __asm__("
  movl    8(%ebp),%edx
  inb     %dx,%al
  movzbl  %al,%eax                  
  ");
}

unsigned char outportb(arg1,arg2)
{
  __asm__("
  movl    0x8(%ebp),%edx
  movl    0xc(%ebp),%eax
  outb    %al,%dx
  ");
}

unsigned short int inport(unsigned int arg1)
{
  __asm__("
  movl    8(%ebp),%edx
  inw     %dx,%ax
  ");
}

unsigned short int outport(unsigned int arg1,unsigned int arg2)
{
  __asm__("
  movl    0x8(%ebp),%edx
  movl    0xc(%ebp),%eax
  outw    %ax,%dx
  ");
}

/*
    This file was part of the source of talk64 V1.5,
    a PC - DoctorV64 communications program
    Copyright (C) 1997  Andreas Sterbenz (stan@sbox.tu-graz.ac.at)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
*/

void out1byte(unsigned int port, unsigned char c)
{
  __asm__ volatile ("outb %0,%1"
		    ::"a" ((char) c), "d"((unsigned short) port));
}

unsigned char in1byte(unsigned int port)
{
  char _v;
  __asm__ volatile ("inb %1,%0"
		    :"=a" (_v):"d"((unsigned short) port));

  return _v;
}

int setIoPerm(unsigned int port, int nr, int val)
{
  if(ioperm(port, nr, val)!=0)return(-1);
  return(0);
}

#define DETECT_MAX_CNT 1000

int detectParPort(unsigned int port)
{
  int i;

  if(setIoPerm(port, 1, 1)==-1)return(-1);
  out1byte(port, 0xaa);
  for( i=0; i<DETECT_MAX_CNT; i++ ) {
    if( in1byte(port) == 0xaa ) break;
  }
  if( i < DETECT_MAX_CNT ) {
    out1byte(port, 0x55);
    for( i=0; i<DETECT_MAX_CNT; i++ ) {
      if( in1byte(port) == 0x55 ) break;
    }
  }
  if(setIoPerm(port, 1, 0)==-1)return(-1);
  
  if( i >= DETECT_MAX_CNT ) return 0;
  return 1;
}
unsigned int getParPort(unsigned int port)
{
  uid_t uid;
  unsigned int parPortAddresses[] = { 0x3bc, 0x378, 0x278 };
  int i;
  
  if( port == 0 ) port = 1;
  if( port <= 3 ) {
    for( i=0; i<3; i++ ) {
      port -= detectParPort(parPortAddresses[i]);
      if( port == 0 ) {
        port = parPortAddresses[i];
        break;
      }
    }
    if( i >= 3 ) return (0);
  } else {
    if( (port != parPortAddresses[0]) && (port != parPortAddresses[1]) && (port != parPortAddresses[2]) ) {
	return(0);
    }
  }
  if( port != 0 ) {
    if(setIoPerm(port, 3, 1)==-1)return(0);
    uid = getuid();
    seteuid(uid);
  }
  return port;
}

void dump_buffer(void)
{
for (i=0; i<128 ; i++)
   {
   j=i & 0x0f;
   disp_buf[j]=mix.buffer[i];
   if (j==15)
      {
      printf("%04x : ",i&0xfff0);
      for (j=0; j<16 ; j++)
	 {
	 if (j==8) printf("- ");
	 printf("%02x ",disp_buf[j]);
	 }
      printf("-> ");
      for (j=0; j<16 ; j++)
	 {
	 if (disp_buf[j] < 0x20 || disp_buf[j] > 0x80)
	    printf (".");
	 else
	    printf ("%c",disp_buf[j]);
	 }
      printf("\n");
      }
   }
}

void set_ai(unsigned char _ai)
{
   outportb(port_a,5);			// ninit=1, nwrite=0
   outportb(port_b,_ai);
}

void set_ai_data(unsigned char _ai,unsigned char _data)
{
   set_ai(_ai);
   outportb(port_a,1);		// ninit=0, nwrite=0
   outportb(port_c,_data);
}

void init_port(void)
{
   outportb(port_9,1);		// clear EPP time flag
   set_ai_data(6,0x0a);
   set_ai_data(7,0x05);		// 6==0x0a, 7==0x05 is pc_control mode
//   set_ai(5);
//   outportb(port_a,0);
//   write_en=inportb(port_c);
   set_ai_data(5,write_en);		// d0=0 is write protect mode
}

void end_port(void)
{
   set_ai_data(5,write_en);		// d0=0 is write protect mode
   set_ai_data(7,0);		// release pc mode
   set_ai_data(6,0);		// 6==0x0a, 7==0x05 is pc_control mode
   outportb(port_a,4);			// ninit=1, nWrite=1
}

char write_32k(unsigned short int hi_word, unsigned short int lo_word)
{
   unsigned char unpass,pass1;
   unsigned short int i,j;
   unsigned short int fix,temp;
   init_port();
   set_ai_data(3,0x10|(hi_word>>8));
   set_ai_data(2,(hi_word & 0xff));
   for (i=0;i<0x40;i++){
      unpass=3;
      while(unpass){
	 set_ai_data(1,((i<<1)|lo_word));
	 set_ai_data(0,0);
	 set_ai(4);		// set address index=4
	 outportb(port_a,1);		// ninit=0, nWrite=0
	 fix=i<<8;
	 for (j=0;j<256;j++){
	    outport(port_c,mix.bufferx[j+fix]);
	 }
	 outportb(port_a,0);		// ninit=0, nWrite=1
	 if (wv_mode){
	    for (j=0;j<256;j++){
	       temp=inport(port_c);
	       if(mix.bufferx[j+fix]!=temp){
//		  printf("%2x%2x dram=%x, buffer=%x\n",i,j*2,temp,mix.bufferx[j+fix]);
		  break;
	       }
	    }
	 }
	 else{
	    pass1=1;
	    for (j=0;j<4;j++){
	       temp=inport(port_c);
	       if(mix.bufferx[j+fix]!=temp){
//		  printf("%2x%2x dram=%x, buffer=%x\n",i,j*2,temp,mix.bufferx[j+fix]);
		  pass1=0;
		  break;
	       }
	    }
	    if (pass1) {
//	       printf("@");
	       set_ai_data(1,((i<<1)|lo_word|1));
	       set_ai_data(0,0xf8);
	       set_ai(4);
	       outportb(port_a,0);		// ninit=0, nWrite=1
	       for (j=252;j<256;j++){
		  temp=inport(port_c);
		  if(mix.bufferx[j+fix]!=temp){
//		     printf("%2x%2x dram=%x, buffer=%x\n",i,j*2,temp,mix.bufferx[j+fix]);
		     break;
		  }
	       }
	    }
	 }
	 set_ai(0);
	 outportb(port_a,0);			// ninit=0, nwrite=1
	 if (inportb(port_c)!=0x00){
	    unpass--;
//	    printf("counter=%x ",inportb(data));
	    outportb(port_a,0x0b);	// set all pin=0 for debug
	    if (disp_on) printf("*");
	    init_port();
	    set_ai_data(3,0x10|(hi_word>>8));
	    set_ai_data(2,(hi_word & 0xff));
	    if (unpass==0)
	       return(1);
	 }
	 else
	    unpass=0;
      }
   }
//   outportb(ai,0);
//   printf("\na[7..0]=%02x\n",inportb(data));
//   outportb(ai,1);
//   printf("a[15..8]=%02x\n",inportb(data));
//   end_port();
   return(0);
}

char verify_32k(unsigned short int hi_word, unsigned short int lo_word)
{
   char unpass;
   unsigned short int i,j,temp;
   unsigned short int fix;
   init_port();
   set_ai_data(3,0x10|(hi_word>>8));
   set_ai_data(2,(hi_word & 0xff));
//   set_ai_data(3,0x10);
//   set_ai_data(2,hi_word);
   for (i=0;i<0x40;i++){
      unpass=3;
      while(unpass){
	 set_ai_data(1,((i<<1)|lo_word));
	 set_ai_data(0,0);
	 set_ai(4);
	 outportb(port_a,0);			// ninit=0, nwrite=1
	 fix=i<<8;
	 for (j=0;j<256;j++){
	    temp=inport(port_c);
	    if (temp!=mix.bufferx[j+fix]){
//	       printf("verify error!!!\07\n");
//	       printf("%2x%2x dram=%x, buffer=%x\n",i,j*2,temp,mix.bufferx[j+fix]);
	       outportb(port_a,0x0b);	// all pin=0 for debug
	       if (disp_on) printf("#");
	       init_port();
	       set_ai_data(3,0x10|(hi_word>>8));
	       set_ai_data(2,(hi_word & 0xff));
	       unpass--;
	       if (unpass==0)
		   return(1);
	       else
		  break;
	    }
	 }
	 if (j==256) break;
      }
   }
//   outportb(ai,0);
//   printf("\na[7..0]=%02x\n",inportb(data));
//   outportb(ai,1);
//   printf("a[15..8]=%02x\n",inportb(data));
//   end_port();
   return(0);
}

void read_adr(void)
{
   set_ai_data(6,0x0a);		// enable pc mode
   set_ai_data(7,0x05);		// enable pc mode
   printf("\na[31..0]=");
   set_ai(3);
   outportb(port_a,0);		// ninit=0, nwrite=1
   printf("%02x",inportb(port_c));
   set_ai(2);
   outportb(port_a,0);		// ninit=0, nwrite=1
   printf("%02x",inportb(port_c));
   set_ai(1);
   outportb(port_a,0);		// ninit=0, nwrite=1
   printf("%02x",inportb(port_c));
   set_ai(0);
   outportb(port_a,0);		// ninit=0, nwrite=1
   printf("%02x\n",inportb(port_c));
   end_port();
}

void read_some(void)
{
   init_port();
   set_ai_data(0,0);
   set_ai_data(1,0);
   set_ai_data(2,0);
   set_ai_data(3,0x10);
   set_ai(4);
   outportb(port_a,0);		// ninit=0, nWrite=1
   for (i=0;i<64;i++) {
      mix.bufferx[i]=inport(port_c);
   }
   dump_buffer();
   read_adr();
}

unsigned char check_card(void)
{
   init_port();
   set_ai_data(3,0x12);
   set_ai_data(2,0x34);
   set_ai_data(1,0x56);
   set_ai_data(0,0x78);
   set_ai(3);
   outportb(port_a,0);		// ninit=0, nwrite=1
   if ((inportb(port_c)&0x1f)!=0x12) return(1);
   set_ai(2);
   outportb(port_a,0);		// ninit=0, nwrite=1
   if (inportb(port_c)!=0x34) return(1);
   set_ai(1);
   outportb(port_a,0);		// ninit=0, nwrite=1
   if (inportb(port_c)!=0x56) return(1);
   set_ai(0);
   outportb(port_a,0);		// ninit=0, nwrite=1
   if (inportb(port_c)!=0x78) return(1);
   end_port();
   return(0);
}

short int read_file(void)
{
   if (fread((char *)mix.buffer,sizeof(char),32768,fptr)!=32768)
      {
      fclose(fptr);	/* read data error */
      return(-1);
      }
   printf(".");
   fflush(stdout);
   return(0);
}

short int download_n64()
{
   if((fptr=fopen(file_name,"rb"))==NULL)
      {/* open error */
      printf("open error !!!\07\n");
      return(-1);
      }
   if (sel==0)
      printf("Downloading");
   else
      printf("Verifying");
   for (page=0;page<0x200;page++) {
      if (read_file()!=0){
	 /*fclose(fptr);*/
	 printf("\n");
	 return (0);
      }
      if (sel==0){
	 if (write_32k(page,0)) {
	    read_adr();
	    /*fclose(fptr);*/
	    return(-1);
	 }
      }
      else{
	 if(verify_32k(page,0)) {
	    read_adr();
	    /*fclose(fptr);*/
	    return(-1);
	 }
      }
      if (read_file()!=0){
	 /*fclose(fptr);*/
	 return (-1);
      }
      if (sel==0){
	 if (write_32k(page,0x80)) {
	    read_adr();
	    /*fclose(fptr);*/
	    return(-1);
	 }
      }
      else{
	 if(verify_32k(page,0x80)) {
	    read_adr();
	    /*fclose(fptr);*/
	    return(-1);
	 }
      }

      }
   printf("\n");
   /*fclose(fptr);*/
   end_port();
   return(0);
}

void gen_pat_32k(unsigned short int offset)
{
   for (i=0; i<0x4000; i++){
      mix.bufferx[i]=i+offset;
   }
}


unsigned short int test_dram(void)
{
   unsigned short int pages;
   disp_on=0;		// display off
   sel=0;		//write 32k dram data
   gen_pat_32k(0x0000);
   write_32k(0,0);
   gen_pat_32k(0x8000);
   write_32k(0x100,0);
   gen_pat_32k(0x0000);
   pages=0;
   if (verify_32k(0,0)==0){	// find lower 128Mbits
      pages=0x100;
   }
   gen_pat_32k(0x8000);
   if (verify_32k(0x100,0)==0){	// find upper 128Mbits
      pages=0x200;
   }
   printf("DRAM testing...");
   for (page=0; page<pages; page++){
       gen_pat_32k(page*2);
       if (write_32k(page,0))
	  return(0);
       else
	  printf("w");
       fflush(stdout);
       gen_pat_32k(page*2 +1);
       if (write_32k(page,0x80))
	  return(0);
       else
	  printf("w");
       fflush(stdout);
   }
   for (page=0; page<pages; page++){
       gen_pat_32k(page*2);
       if (verify_32k(page,0))
	  return(0);
       else
	  printf("v");
       fflush(stdout);
       gen_pat_32k(page*2 +1);
       if (verify_32k(page,0x80))
	  return(0);
       else
	  printf("v");
       fflush(stdout);
   }
   return(pages);
}

/*


void usage(char *progname)
{
   fprintf(stderr, "Usage: %s [-w] [-v] [-t] [-a] <File>\n", progname);
   fprintf(stderr, "-w : DRAM write protect disabled.\n");
   fprintf(stderr, "-v : verify File data vs DRAM data.\n");
   fprintf(stderr, "-t : test DRAM.\n");
   fprintf(stderr, "-a : enable cartridge and unprotect.\n");
   exit(2);
}
*/

int transferv64jr(char *name,char *port,int swapped)
{
   char card_present;
   unsigned short int dram_size;
int parallelport=0;

	sscanf(port,"%x",&parallelport);
	if(!(parallelport=getParPort(parallelport)))return(-1);
	printf("Port: 0x%x\n",parallelport);
	printf("Swapped: %s\n",(!swapped)?"No":"Yes");

   ioperm(parallelport, 6, 1);

      if (check_card()==0){
	 card_present=1;
      }

   if (card_present==0){
      printf("\nNo V64jr card present!!!\07\n\n");
      return(-1);
   }
   else
      printf("V64jr card found at port%d\n",port_no);
   init_port();
   set_ai(3);
   outportb(port_a,0);
   printf("control(rst,wdf,rcf) = %x\n",inportb(port_c));


   if (test_en){
      dram_size=test_dram();
      if (dram_size){
	 printf("\nDRAM size=%dMbits\n",(dram_size/2));
      }
      else {
	 printf("Error!!!\07\n");
      }
   }
   disp_on=1;		// display
   if (file_name!=NULL){
      if (download_n64()!=0)
	 printf("download error !!!\n");
   }
   if (write_en)
      printf("dram write protect disable\n");
   if (write_en & 2)
      printf("run cart enable\n");

//   set_ai_data(5,write_en);		// d0=0 is write protect mode
   end_port();
   return(0);
}

#endif
#ifdef MSDOS
#include <stdio.h>
#include <dos.h>
#include <conio.h>

unsigned int getParPort(unsigned int port)
{
  int far *biosport;
  int i;

  biosport = (void *)0x00400008;
  if( port == 0 ) port = 1;
  if( port<=3 ) return biosport[port-1];
  for( i=0; i<4; i++ ) {
    if( biosport[i] != 0 ) {
      if( port == biosport[i] ) return biosport[i];
    }
  }
  if( port != 0 ) {
    printf("WARNING: Bios does not know about a parallel port at %4X!\n", port);
  }
  return port;
}

#define out1byte(x,y) outportb(x,y)
//void out1byte(unsigned int port, unsigned char c)
//{
//  outportb(port, c);
//}

#define in1byte(x) inportb(x)
//unsigned char in1byte(unsigned int port)
//{
//  return inportb(port);
//}
#endif




















#define HEADER_MAGIC 0x80371240

#define SEND_MAX_WAIT 0x300000
#define REC_MAX_WAIT SEND_MAX_WAIT

#define REC_HIGH_NIBBLE 0x80
#define REC_LOW_NIBBLE 0x00

#define SYNC_MAX_CNT 8192
#define SYNC_MAX_TRY 32

int syncHeader(unsigned int baseport)
{
int i=0;

out1byte(baseport, 0);                        /* data = 00000000    */
out1byte(baseport+2, 4);                      /* ~strobe=0          */
while( i<SYNC_MAX_CNT ) 
{
	if( (in1byte(baseport+2) & 8) == 0 )      /* wait for select=0  */
	{
      		out1byte(baseport, 0xaa);                 /* data = 10101010    */
      		out1byte(baseport+2, 0);                  /* ~strobe=0, ~init=0 */
      		while( i<SYNC_MAX_CNT ) 
      		{
        		if( (in1byte(baseport+2) & 8) != 0 )  /* wait for select=1  */
        		{
				out1byte(baseport+2, 4);              /* ~strobe=0          */
          			while( i<SYNC_MAX_CNT ) 
          			{
            				if( (in1byte(baseport+2) & 8) == 0 ) /* w for select=0  */
            				{
				              out1byte(baseport, 0x55);         /* data = 01010101    */
				              out1byte(baseport+2, 0);          /* ~strobe=0, ~init=0 */
				              while( i<SYNC_MAX_CNT ) 
				              {
                					if( (in1byte(baseport+2) & 8) != 0 )   /* w select=1 */
                					{
                  						out1byte(baseport+2, 4);      /* ~strobe=0          */
                  						while( i<SYNC_MAX_CNT )
                  						{
                    							if( (in1byte(baseport+2) & 8) == 0)  /* select=0 */
                      							{
                      								return 0;
			                    				}
                    							i++;
                  						}
                					}
                					i++;
              					}
            				}
            				i++;
          			}
        		}
        		i++;
      		}
      		i++;
    	}
    	i++;
}
out1byte(baseport+2, 4);
return 1;
}

int initCommunication(unsigned int port)
{
	int i;
	for( i=0; i<SYNC_MAX_TRY; i++ ) 
	{
		if( syncHeader(port) == 0 ) break;
	}
	if( i>=SYNC_MAX_TRY )  return(-1);
	return(0);
}

int sendBytes(unsigned int baseport, unsigned int len, char data[], int swap)
{
long maxwait;
unsigned int i;

for( i=0; i<len; i++ ) 
{
	maxwait = SEND_MAX_WAIT;
	if( (in1byte(baseport+2) & 1) == 0 )       /* check ~strobe */
	{
		while( ((in1byte(baseport+2) & 2) != 0) && maxwait-- ) ;  /* wait for */
		if( maxwait <= 0 ) return 1;                        /* auto feed == 0 */
		out1byte(baseport, data[i^swap]);         /* write data    */
		out1byte(baseport+2, 5);                  /* ~strobe = 1   */
	}
	else
	{
		while( ((in1byte(baseport+2) & 2) == 0) && maxwait-- ) ;  /* wait for */
		if( maxwait <= 0 ) return 1;                        /* auto feed == 1 */
		out1byte(baseport, data[i^swap]);         /* write data    */
		out1byte(baseport+2, 4);                  /* ~strobe = 0   */
	}
}
return 0;
}

int receiveBytes(unsigned int baseport, unsigned int len, char data[], int swap)
{
int i;
long maxwait;
unsigned char c;

for( i=0; i<len; i++ ) 
{
	out1byte(baseport, REC_HIGH_NIBBLE);
	maxwait = REC_MAX_WAIT;
	while( ((in1byte(baseport+1) & 0x80) == 0) && maxwait-- ) ; /* wait for ~busy=1 */
	if( maxwait <= 0 ) return len-i;
	c = (in1byte(baseport+1) >> 3) & 0x0f; /* ~ack, pe, slct, ~error */

	out1byte(baseport, REC_LOW_NIBBLE);
	maxwait = REC_MAX_WAIT;
	while( ((in1byte(baseport+1) & 0x80) != 0) && maxwait-- ) ; /* wait for ~busy=0 */
	if( maxwait <= 0 ) return len-i;
	c |= (in1byte(baseport+1) << 1) & 0xf0; /* ~ack, pe, slct, ~error */

	data[i^swap] = c;
}
out1byte(baseport, REC_HIGH_NIBBLE);
return 0;
}

int checkSync(unsigned int baseport)
{
  int i, j;

for( i=0; i<SYNC_MAX_CNT; i++ ) 
{
    	if( ((in1byte(baseport+2) & 3) == 3) || ((in1byte(baseport+2) & 3) == 0) ) 
    	{
      		out1byte(baseport, 0);                        /* ~strobe, auto feed */
      		for( j=0; j<SYNC_MAX_CNT; j++ ) 
      		{
        		if( (in1byte(baseport+1) & 0x80) == 0 )   /* wait for ~busy=0 */
        		{
          			return 0;
        		}
      		}
      		return 1;
    	}
}
return 1;
}

int sendFilename(unsigned int baseport, char name[])
{
  int i;
  char *c;
  char mname[12];

  memset(mname, ' ', 11);
  c = (strrchr(name, '/')>strrchr(name, '\\'))?strrchr(name, '/'):strrchr(name, '\\');
  if( c == NULL ) {
    c = name;
  } else {
    c++;
  }
  for( i=0; i<8 && *c!='.' && *c!='\0' ; i++, c++ ) mname[i] = toupper(*c);
  c = strrchr(c, '.');
  if( c != NULL ) {
    c++;
    for( i=8; i<11 && *c!='\0'; i++, c++ ) mname[i] = toupper(*c);
  }
//mname[0]='u';
//mname[1]='C';
//mname[2]='O';
//mname[3]='N';
//mname[4]='6';
//mname[5]='4';

  return sendBytes(baseport, 11, mname, 0);
}

int sendUploadHeader(unsigned int baseport, char name[], long len)
{
  char mname[12];

  char lenbuffer[4];
  static char protocolId[] = "GD6R\1";

  if( sendBytes(baseport, strlen(protocolId), protocolId, 0) != 0 ) return 1;

  lenbuffer[0] = (len    );
  lenbuffer[1] = (len>> 8);
  lenbuffer[2] = (len>>16);
  lenbuffer[3] = (len>>24);
  if(sendBytes(baseport, 4, lenbuffer, 0) != 0 ) return 1;

  memset(mname, ' ', 11);
//  if( 
sendFilename(baseport,name);
//   != 0 ) return 1;
  return 0;
}

int sendDownloadHeader(unsigned int baseport, char name[], long *len)
{
char mname[12];

  static char protocolId[] = "GD6W";
  unsigned char recbuffer[15];

  if( sendBytes(baseport, strlen(protocolId), protocolId, 0) != 0 ) return 1;
memset(mname, ' ', 11);
  if( sendBytes(baseport, 11, mname, 0) != 0 ) return 1;
  if( checkSync(baseport) != 0 ) return 1;
  if( receiveBytes(baseport, 1, (char *)recbuffer, 0) != 0 ) return 1;
  if( recbuffer[0] != 1 ) {
    return(-1);
  }
  if( receiveBytes(baseport, 15, (char *)recbuffer, 0) != 0 ) return 1;
  *len = (long)recbuffer[0] | ((long)recbuffer[1] << 8) | ((long)recbuffer[2] << 16) | ((long)recbuffer[3] << 24);
  return(0);
}



















#define TRANSFER_UNKNOWN 0
#define TRANSFER_V64	1
#define TRANSFER_V64JR 2

int transfer(char *name,int copier,char *port,int swapped)
{
char buf[32768];
unsigned long hsize=0;
FILE *fh;
unsigned long size,len;
int parallelport=0;

char *romname=name;
//char *option2=port;

if(copier==TRANSFER_V64JR)
{
return(	transferv64jr(name,port,swapped));
}

	sscanf(port,"%x",&parallelport);
	if(!(parallelport=getParPort(parallelport)))return(-1);
	printf("Port: 0x%x\n",parallelport);
	printf("Swapped: %s\n",(!swapped)?"No":"Yes");

	if(initCommunication(parallelport)==-1)return(-1);

	if((fh=fopen(romname,"rb"))!=0)
	{
	  	if(sendUploadHeader(parallelport,romname,fsize(romname,hsize))!=0)return(-1);
	
		printf("Send: %ld bytes (%.4f MBit)\n\n", fsize(romname,hsize), (float)fsize(romname,hsize)/MBIT);
		size=fsize(romname,0);
	
		for(;;)
		{
	                if(!(len=fread(buf,1,sizeof(buf),fh)))break;
	    		if(sendBytes(parallelport,len,buf,swapped^1)!=0)
//	    		break;
{
//printf("SHIT2");
//fflush(stdout);
break;
}
		    	size=size-len;
			fgauge(fsize(romname,hsize)-size,fsize(romname,hsize));
		}
	}
	else
	{
//wenn durch MBIT teilbar dann auch MBIT anzeigen!

	  	if(sendDownloadHeader(parallelport,romname,&size)!=0)return(-1);
		if(!(fh=fopen(romname,"wb")))return(-1);
		printf("Receive: %ld bytes (%.4f MBit)\n\n", size, (float)size/MBIT);
		
	  	for(;;)
	  	{
	    		if(receiveBytes(parallelport,sizeof(buf),buf,swapped^1)!=0)
		  	{
				fclose(fh);
//				remove(romname);
				return(0);
		  	}
	    		fwrite(buf,1,sizeof(buf),fh);
			fgauge(fsize(romname,0),size);
	  	}
	}
	fclose(fh);
	printf("\n");
return(0);
}












































/*
        if( strstr(c, "bios") == c ) 
        {
	        char t2[MAX_STRING_LENGTH];
	        char *d=t2;
	        c += strlen("bios");

          	while( *c != '\0' ) 
          	{
            		if( isdigit(*c) ) *d++ = *c;
            		c++;
          	}
          	*d = '\0';
          	if( sscanf(t2, "%x", &biosVersion) != 1 ) usage();
          	if( (biosVersion < 0x0100) || (biosVersion > 0x0999) ) 
          	{
            		printf("%s: Please specify the BIOS version with three digits, e.g. -bios122.\n", arg);
            		exit(1);
          	}
          	continue;
        }
        else if( *c=='l' ) 
        {
          	if( *(c+1) == '\0' ) 
          	{
          	  	slen = -2;
          	  	continue;
          	}
          	if( strlen(c)>BUFSIZE ) usage();
          	if( sscanf(c+1, "%ld%s", &slen, buf) != 1 ) 
          	{
            		if( sscanf(c+1, "%ldM%s", &slen, buf) == 1 ) 
            		{
              			slen <<= 17;
            		} 
            		else usage();
          	}
        } 
        else if( (*c == 'a') && (*(c+1) == '\0') ) 
        {
          	int j, k, l, p=0;
          	for( j=i+1; j<argc; j++ ) 
          	{
            		l = strlen(argv[j]);
            		for( k=0; (k<l) && (p<MAX_STRING_LENGTH-1); k++, p++ ) 
            		{
              			romParameters[p] = argv[j][k];
            		}
            		if( (j < argc-1) && (p<MAX_STRING_LENGTH-1) ) romParameters[p++] = ' ';
          	}
          	romParameters[HEADER_NAME_LEN-1] = '\0';
          	break;
        } 
        else usage();
*/
