void usage(void)
{
printf("\
USAGE: %s [OPTION(S)] ROM [FILE]\n\
\n\
USE -<CONSOLE> FORCE/OVERRIDE OPTION IF AUTO-DETECTION FAILS\n\
\n\
TODO: $ROM could also be the name of a *.ZIP archive\n\
      it will automatically find and extract the ROM\n\
\n\
TODO:  -faq,-hh	frequently answers and questions\n\
  -db		ROM database statistics (# of entries)\n\
  -dbv		view ROM database (all entries)\n\
  -rn		rename all files in DIRECTORY to lowercase; $ROM=DIRECTORY\n\
  -hex		show ROM as hexdump; use \"%s -hex $ROM|less\"\n\
TODO:  -id	generate FILE_ID.DIZ for ROM\n\
  -c		compare ROMs; $FILE=OTHER ROM\n\
  -cs		compare ROMs for similarities; $FILE=OTHER ROM\n\
  -find		find string in ROM; $FILE=STRING\n\
  -cdrom	show (CD)ROM info; $ROM=/dev/<cdrom>\n\
  -swap		swap (ALL) bytes in ROM (1234<->2143)\n\
  -pad		pad ROM to full MBit(s) (ignore possible headers)\n\
  -ispad	check if ROM is padded\n\
  -stp		strip first 512 bytes (possible header) from ROM\n\
  -ins		insert 512 bytes (0x00) before ROM\n\
  -b		apply Baseline/BSL patch (<=x.x); $FILE=PATCHFILE\n\
  -i		apply IPS patch (<=1.2); $FILE=PATCHFILE\n\
  -a		apply APS patch (<=1.2); $FILE=PATCHFILE\n\
  -mki		create IPS patch; $FILE=CHANGED ROM\n\
  -mka		create APS patch; $FILE=CHANGED ROM\n\
  -na		change APS description; $ROM=PATCHFILE $FILE=DESCRIPTION\n\
TODO:  -aps	convert Baseline/BSL/IPS to APS; $ROM=PATCHFILE\n\
\n\
%s\n\
  -n64		force Nintendo 64\n\
  -swp		force ROM is swapped (2143)\n\
  -nswp		force ROM is not swapped (1234)\n\
  *		show info (default)\n\
  -n		change ROM name; $FILE=NEWNAME\n\
  -v64		convert to Doctor V64 (and compatibles/swapped)\n\
  -z64		convert to Z64 (Zip Drive/not swapped)\n\
  -xv64		send(auto-receive) to(from) Doctor V64; $FILE=PORT\n\
  -xvjr		send(auto-receive) to(from) Doctor V64 Jr; $FILE=PORT\n\
		auto-receive when $ROM does not exist\n\
\n\
*** I've got no Doctor V64 Jr and couldn't test -xvjr\n\
*** Report problems/fixes to nb@g-ewalt.de (Dirk)\n\
\n\
TODO:  -f	remove NTSC/PAL protection\n\
  -bot		add(auto-extract) boot code to(from) ROM; $FILE=BOOTCODE\n\
		auto-extract when $FILE does not exist (4032 bytes)\n\
                supports: 6101, 6102, 6103, 6105 and 6106 boot codes\n\
  -sram		LAC's Makesram; $ROM=(LAC's SRAM ROM image) $FILE=SRAMFILE\n\
  		the SRAMFILE must have a size of 512 bytes\n\
  -usms		Jos Kwanten's ultraSMS (Sega Master System/GameGear Emulator);
		$ROM=(Jos Kwanten's ultraSMS ROM image) $FILE=SMSROM(<=4MBit)\n\
TODO:		auto-extract when $FILE does not exist\n\
  -chk		fix ROM checksum\n\
TODO:  -bios	enable backup in Doctor V64 BIOS; $ROM=BIOS\n\
TODO:  -gs	apply GameShark code (permanent); $FILE=CODE\n\
\n\
%s\n\
  -psx		force PlayStation/PlayStation One; NEEDED\n\
  *		show info (default); $ROM=/dev/<cdrom>\n\
TODO:  -xa	convert CDXA sound to WAV; $ROM=CDXAFILE\n\
\n\
%s\n\
  -jag		force Jaguar(CD)\n\
  -hd		force ROM has header (+512 bytes)\n\
  -nhd		force ROM has no header\n\
  *		show info (default); $ROM=ROM or $ROM=/dev/<cdrom>\n\
\n\
%s\n\
  -snes		force Super Nintendo/Super Famicon\n\
  -hi		force ROM is HiROM\n\
  -nhi		force ROM is not HiROM\n\
  -hd		force ROM has SMC/FIG/SWC header (+512 bytes)\n\
  -nhd		force ROM has no SMC/FIG/SWC header (MGD2/MGH/RAW)\n\
  *		show info (default)\n\
  -n		change ROM name; $FILE=NEWNAME\n\
  -smc		convert to Super Magicom/SMC (autojoin)\n\
  -fig		convert to *Pro Fighter*/(all)FIG (autojoin)\n\
  -swc		convert to Super Wild Card*/(all)SWC (autojoin)\n\
  -mgd		convert to Multi Game*/MGD2/MGH/RAW (autojoin)\n\
  -gd3		convert to Professor SF(2) Game Doctor SF3/6/7 (autojoin)\n\
TODO:  -xsmc	send(auto-receive) to(from) Super Magicom/SMC; $FILE=PORT\n\
TODO:  -xfig	send(auto-receive) to(from) *Pro Fighter*/(all)FIG; $FILE=PORT\n\
TODO:  -xswc	send(auto-receive) to(from) Super Wild Card*/(all)SWC;\n\
		$FILE=PORT\n\
TODO:  -xmgd	send(auto-receive) to(from) Multi Game*/MGD2/MGH/RAW;\n\
		$FILE=PORT\n\
		auto-receive when $ROM does not exist\n\
  -col		convert 0xRRGGBB (html) <-> 0xXXXX (snes); $ROM=0xCOLOR\n\
		this routine was used to find green colors in games and\n\
		to replace them with red colors (blood mode)\n\
TODO:  -sx	convert to Snes9X (Emulator)/S9X save state; $ROM=SAVESTATE\n\
TODO:  -zs	convert to ZSNES (Emulator) save state; $ROM=SAVESTATE\n\
TODO:  -xzs	extract GFX from ZSNES (Emulator) save state; $ROM=SAVESTATE\n\
TODO:  -spc	convert SPC sound to WAV; $ROM=SPCFILE\n\
  -j		join splitted ROM\n\
    		for the following options the ROM must be joined\n\
  -s		split ROM into 4MBit parts (for backup unit(s) with fdd)\n\
  -p		pad ROM to full MBit(s)\n\
TODO:  -k	remove protection (crack)\n\
  -f		remove NTSC/PAL protection\n\
  -l		convert to LoROM/SlowROM\n\
  -chk		fix ROM checksum\n\
  -gdf		fix Professor SF(2) Game Doctor SF3/6/7 savegame problems\n\
  -gg		apply GameGenie code (permanent); $FILE=CODE-CODE\n\
\n\
%s\n\
  -ng		force Neo Geo/Neo Geo CD(Z)/MVS/(M.A.M.E.); NEEDED\n\
  *		show info (default); $ROM=ROM or $ROM=/dev/<cdrom>\n\
TODO:  -mgd	convert to Multi Game Doctor/MGD2/RAW (autojoin)\n\
TODO:  -mvs	convert to Arcade/MVS (autojoin)\n\
TODO:  -ngs	convert Neo Geo sound to WAV; $ROM=*_m1.rom or *_v*.rom\n\
TODO:  -j	join splitted ROM\n\
    		for the following options the ROM must be joined\n\
TODO:  -s	split ROM into 4MBit parts (for backup unit(s) with fdd)\n\
TODO:  -chkm	check/fix Multiple Arcade Machine Emulator/M.A.M.E. ROMs;\n\
		$ROM=DIRECTORY\n\
TODO:  -sam	convert SAM/M.A.M.E. sound to WAV; $ROM=SAMFILE\n\
TODO: show info for ROMs\n\
\n\
%s\n\
  -ngp		force Neo Geo Pocket/Neo Geo Pocket Color\n\
TODO:  *	show info (default)\n\
TODO:  -xpl	send(auto-receive) to(from) Pocket Linker/Flash; $FILE=PORT\n\
		auto-receive when $ROM does not exist\n\
\n\
%s\n\
  -gen		force Genesis/Sega Mega Drive/Sega CD/32X/Nomad\n\
  -hd		force ROM has SMD header (+512 bytes)\n\
  -nhd		force ROM has no SMD header (MGD2/MGH/RAW)\n\
  *		show info (default); $ROM=ROM or $ROM=/dev/<cdrom>\n\
  -smd		convert to Super Magicom Drive/SMD (autojoin)\n\
  -mgd		convert to Multi Game*/MGD2/MGH/RAW (autojoin)\n\
TODO:  -gf	convert Sega CD country code to Europe; ROM=$ISOFILE\n\
TODO:  -ga	convert Sega CD country code to U.S.A.; ROM=$ISOFILE\n\
TODO:  -xsmd	send(auto-receive) to(from) Super Magicom Drive/SMD; $FILE=PORT\n\
TODO:  -xmgd	send(auto-receive) to(from) Multi Game*/MGD2/MGH/RAW;\n\
		$FILE=PORT\n\
		auto-receive when $ROM does not exist\n\
TODO:  -gc	convert to Genecyst (Emulator)/GSV save state; $ROM=SAVESTATE\n\
TODO:  -ge	convert to GenEm (Emulator)/SAV save state; $ROM=SAVESTATE\n\
TODO:  -gym	convert GYM sound to WAV; $ROM=GYMFILE\n\
  -j		join splitted ROM\n\
    		for the following options the ROMs must be joined\n\
  -n		change foreign ROM name; $FILE=NEWNAME\n\
  -n2		change japanese ROM name; $FILE=NEWNAME\n\
  -s		split ROM into 4MBit parts (for backup unit(s) with fdd)\n\
TODO: split for Super Magicom Drive format\n\
  -p		pad ROM to full MBit(s)\n\
TODO:  -chk	fix ROM checksum\n\
  -1991		fix old third party ROMs to work with consoles build after\n\
		October 1991 by inserting \"(C) SEGA\" and \"(C)SEGA\"\n\
TODO:  -gg	apply GameGenie code (permanent); $FILE=CODE-CODE\n\
\n\
%s\n\
  -gb		force GameBoy/(Super GB)/GB Pocket/Color GB/GB Advance\n\
  -hd		force ROM has SSC header (+512 bytes)\n\
  -nhd		force ROM has no SSC header\n\
  *		show info (default)\n\
  -n		change ROM name; $FILE=NEWNAME\n\
  -mgd		convert to Multi Game*/MGD2/RAW\n\
  -ssc		convert to Super Smart Card/SSC (+512 bytes)\n\
TODO:  -xgbx	send(auto-receive) to(from) GB Xchanger; $FILE=PORT\n\
		auto-receive when $ROM does not exist\n\
  -chk		fix ROM checksum\n\
TODO:  -gg	apply GameGenie code (permanent); $FILE=CODE-CODE\n\
TODO:  -gs	apply GameShark code (permanent); $FILE=CODE\n\
\n\
%s\n\
  -lynx		force Handy/Lynx/Lynx II; NEEDED\n\
  *		show info (default)\n\
TODO:  -lyx	convert to LYX/RAW\n\
TODO:  -lnx	convert to LNX\n\
TODO: show info for LYX ROMs\n\
\n\
%s\n\
  -pce		force PC-Engine/...; NEEDED\n\
  -hd		force ROM has SMG header (+512 bytes)\n\
  -nhd		force ROM has no SMG header (MGD2/RAW)\n\
  *		show info (default); $ROM=ROM or $ROM=/dev/<cdrom>\n\
  -mg		convert to Super Magic Griffin/SMG\n\
  -mgd		convert to Multi Game Doctor*/MGD2/RAW\n\
\n\
%s\n\
  -sms		force Sega Master System(II/III)/GameGear; NEEDED\n\
  -hd		force ROM has header (+512 bytes)\n\
  -nhd		force ROM has no header (MGD2/MGH/RAW)\n\
  *		show info (default)\n\
  -mgd		convert to Multi Game*/MGD2/MGH/RAW\n\
  -smd		convert to Super Magicom Drive/SMD (+512 bytes)\n\
TODO:  -xsmd    send(auto-receive) to(from) Super Magicom Drive/SMD; $FILE=PORT\n\
		auto-receive when $ROM does not exist\n\
TODO:  -chk	fix ROM checksum\n\
TODO:  -gg	apply GameGenie code (permanent); $FILE=CODE-CODE\n\
TODO: show more detailed ROM info\n\
\n\
%s\n\
  -c64		force Commodore 64/Commodore 128\n\
TODO:  *	show info/contents (default);\n\
		$ROM=ROM or $ROM=SIDFILE or $ROM=ARCHIVE\n\
TODO:  -x64	extract D64/T64 archive; $ROM=ARCHIVE\n\
TODO:  -pet	convert PET to ASCII; $ROM=PETFILE\n\
TODO:  -sid	convert SID sound to WAV; $ROM=SIDFILE\n\
TODO: take care of cartridges for the expansion port\n\
\n\
%s\n\
  -nes		force Nintendo Entertainment System/NES\n\
  *		show info/contents (default); $ROM=ROM or $ROM=DISKIMAGE\n\
  -hd		force ROM has FFE header (+512 bytes)\n\
  -nhd		force ROM has no FFE header\n\
  -ffe		convert to FFE (+512 bytes/autojoin)\n\
  -ines		convert to iNES(Emu)/RAW autojoin)\n\
  -ineshd	extract iNES header from ROM (16 bytes)\n\
TODO:  -fam	convert to FAM(jap. Emu)\n\
TODO:  -fds	convert to Famicon DiskSystem/FDS(diskimage/autojoin)\n\
TODO:  -nfs	convert NFS sound to WAV; $ROM=NFSFILE\n\
    		for the following options the ROMs must be joined\n\
TODO:  -pas,-s	convert/split to Pasofami/PRM/PRG/CHR/700 (Emulator)\n\
TODO:  -tr	truncate doubled PRG/CHR/RAM\n\
TODO:  -gg	apply GameGenie code (permanent); $FILE=CODE-CODE\n\
TODO: show contents of FDS disk images\n\
\n\
%s\n\
%s\n\
  -s16		force Sega System 16(A/B)/Sega System 18/dual 68000; NEEDED\n\
  -ata		force Atari 2600/Atari 5200/Atari 7800; NEEDED\n\
\n\
\n\
USE -<CONSOLE> FORCE/OVERRIDE OPTION IF AUTO-DETECTION FAILS\n\
\n\
Report problems/ideas to nb@g-ewalt.de (Dirk)\n\
\n\
",arg,arg,
"Nintendo 64",
"PlayStation/PlayStation One",
"Jaguar(CD)",
"Super Nintendo/Super Famicon",
"Neo Geo/Neo Geo CD(Z)/MVS/(M.A.M.E.)",
"Neo Geo Pocket/Neo Geo Pocket Color",
"Genesis/Sega Mega Drive/Sega CD/32X/Nomad",
"GameBoy/(Super GB)/GB Pocket/Color GB/GB Advance",
"Handy/Lynx/Lynx II",
"PC-Engine (CD Unit/Core Grafx(II)/Shuttle/GT/LT/Super CDROM/DUO(-R(X)))\n\
Super Grafx/Turbo (Grafx(16)/CD/DUO/Express)",
"Sega Master System(II/III)/GameGear",
"Commodore 64/Commodore 128",
"Nintendo Entertainment System/NES",
"Sega System 16(A/B)/Sega System 18/dual 68000",
"Atari 2600/Atari 5200/Atari 7800"
);
exit(0);
}
